var emoji_path = 'emoji/';
var emoji_dict = {
	"[微笑]": "Expression_1",
	"[撇嘴]": "Expression_2",
	"[色]": "Expression_3",
	"[发呆]": "Expression_4",
	"[得意]": "Expression_5",
	"[流泪]": "Expression_6",
	"[害羞]": "Expression_7",
	"[闭嘴]": "Expression_8",
	"[睡]": "Expression_9",
	"[大哭]": "Expression_10",
	"[尴尬]": "Expression_11",
	"[发怒]": "Expression_12",
	"[调皮]": "Expression_13",
	"[呲牙]": "Expression_14",
	"[惊讶]": "Expression_15",
	"[难过]": "Expression_16",
	"[酷]": "Expression_17",
	"[冷汗]": "Expression_18",
	"[抓狂]": "Expression_19",
	"[吐]": "Expression_20",
	"[偷笑]": "Expression_21",
	"[愉快]": "Expression_22",
	"[白眼]": "Expression_23",
	"[傲慢]": "Expression_24",
	"[饥饿]": "Expression_25",
	"[困]": "Expression_26",
	"[恐惧]": "Expression_27",
	"[流汗]": "Expression_28",
	"[憨笑]": "Expression_29",
	"[悠闲]": "Expression_30",
	"[奋斗]": "Expression_31",
	"[咒骂]": "Expression_32",
	"[疑问]": "Expression_33",
	"[嘘]": "Expression_34",
	"[晕]": "Expression_35",
	"[疯了]": "Expression_36",
	"[衰]": "Expression_37",
	"[骷髅]": "Expression_38",
	"[敲打]": "Expression_39",
	"[再见]": "Expression_40",
	"[擦汗]": "Expression_41",
	"[抠鼻]": "Expression_42",
	"[鼓掌]": "Expression_43",
	"[糗大了]": "Expression_44",
	"[坏笑]": "Expression_45",
	"[左哼哼]": "Expression_46",
	"[右哼哼]": "Expression_47",
	"[哈欠]": "Expression_48",
	"[鄙视]": "Expression_49",
	"[委屈]": "Expression_50",
	"[快哭了]": "Expression_51",
	"[阴险]": "Expression_52",
	"[亲亲]": "Expression_53",
	"[吓]": "Expression_54",
	"[可怜]": "Expression_55",
	"[菜刀]": "Expression_56",
	"[西瓜]": "Expression_57",
	"[啤酒]": "Expression_58",
	"[篮球]": "Expression_59",
	"[乒乓]": "Expression_60",
	"[咖啡]": "Expression_61",
	"[饭]": "Expression_62",
	"[猪头]": "Expression_63",
	"[玫瑰]": "Expression_64",
	"[凋谢]": "Expression_65",
	"[嘴唇]": "Expression_66",
	"[爱心]": "Expression_67",
	"[心碎]": "Expression_68",
	"[蛋糕]": "Expression_69",
	"[闪电]": "Expression_70",
	"[炸弹]": "Expression_71",
	"[刀]": "Expression_72",
	"[足球]": "Expression_73",
	"[瓢虫]": "Expression_74",
	"[便便]": "Expression_75",
	"[月亮]": "Expression_76",
	"[太阳]": "Expression_77",
	"[礼物]": "Expression_78",
	"[拥抱]": "Expression_79",
	"[强]": "Expression_80",
	"[弱]": "Expression_81",
	"[握手]": "Expression_82",
	"[胜利]": "Expression_83",
	"[抱拳]": "Expression_84",
	"[勾引]": "Expression_85",
	"[拳头]": "Expression_86",
	"[差劲]": "Expression_87",
	"[爱你]": "Expression_88",
	"[NO]": "Expression_89",
	"[OK]": "Expression_90",
	"[爱情]": "Expression_91",
	"[飞吻]": "Expression_92",
	"[跳跳]": "Expression_93",
	"[发抖]": "Expression_94",
	"[怄火]": "Expression_95",
	"[转圈]": "Expression_96",
	"[磕头]": "Expression_97",
	"[回头]": "Expression_98",
	"[跳绳]": "Expression_99",
	"[投降]": "Expression_100",
	"[激动]": "Expression_101",
	"[街舞]": "Expression_102",
	"[献吻]": "Expression_103",
	"[左太极]": "Expression_104",
	"[右太极]": "Expression_105"
}

function convertEmoji(str, path) {
	var reg = /\[(.*?)\]/gm;
	var img_path = path + emoji_path;
	var result = str.replace(reg, function(match) {
		var img = emoji_dict[match];
		if (img != null && img != '') {
			return '<img class="icon-emoji" src="' + img_path + img + '.png" alt=""/>';
		} else {
			return match;
		}
	});
	return result;
}

function convertEmojiWithKey(str, path) {
    var reg = /\[(.*?)\]/gm;
    var img_path = path + emoji_path;
    var result = str.replace(reg, function(match) {
        var img = emoji_dict[match];
        if (img != null && img != '') {
            return '<img class="icon-emoji" data-key="'+str+'" src="' + img_path + img + '.png" alt=""/>';
        } else {
            return match;
        }
    });
    return result;
}