(function() {

    var post_info = null
    var post_type = 'news' // 默认news，包括 news activity bid marketing product enterprise
    var affix_list = []

    function get_share_url() {
        //return window.config.server_path + '/wap/tmpl/circle/detail.html?c_id='
        //    + post_info.topic_id + '&t_id=' + post_info.id;
        //return "http://a.app.qq.com/o/simple.jsp?pkgname=com.miao.android"
        var host = window.config.server_path;
        //var host = "http://app.jiankangnp.com";
        var url = host + "/h5/share/news.html?id=" + post_info.id
        if(post_type == 'marketing') url = host + "/h5/share/news.html?type=marketing&id=" + post_info.id
        else if(post_type == 'activity') url = host + "/h5/share/activity.html?id=" + post_info.id
        else if(post_type == 'bid') url = host + "/h5/share/bid.html?id=" + post_info.id
        else if(post_type == 'product') url = host + "/h5/share/product.html?id=" + post_info.id
        return url
    }

    function get_title() {
        var title = null;
        if (post_info.title) title = post_info.title
        else if (post_info.name) title = post_info.name
            // if(!title || title == '') {
            //     var str = substrsp(utf16_to_ucs2(post_info.content.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, '')), 0, 50);
            //     var index = str.indexOf('\n');
            //     if (index > 0) {
            //         title = str.substr(0, index);
            //     } else {
            //         title = str;
            //     }
            // }
        return title
    }

    // 分享到微信好友
    function share_to_wechat() {
        log('share_to_wechat')
        var imgurl = post_info.cover ? post_info.cover : post_info.avatar;
        // if (affix_list.length > 0) {
        //     imgurl = affix_list[0];
        // }
        //if(api.systemType == 'ios'){
        //    imgurl = 'widget://res/logo.png'
        //}
        //if(!imgurl) imgurl = 'widget://res/logo.png'
        var data = {
            scene: 'session',
            title: get_title(),
            des: post_info.desc,
            url: get_share_url(),
            thumb: imgurl
        }
        log('share data=' + JSON.stringify(data))
        share_wechat(data, function() {
            sendShare();
        });
    }

    // 分享到微信朋友圈
    function share_to_pengyouquan() {
        var imgurl = post_info.cover;
        //if(api.systemType == 'ios'){
        //    imgurl = 'widget://res/logo.png'
        //}
        //if(!imgurl) imgurl = 'widget://res/logo.png'
        var data = {
            scene: 'timeline',
            title: get_title(),
            des: post_info.desc,
            url: get_share_url(),
            thumb: imgurl
        }
        share_wechat(data, function() {
            sendShare();
        });
    }

    // 分享到QQ好友
    function share_to_qq() {
        var imgurl = post_info.avatar;
        if (affix_list.length > 0) {
            imgurl = affix_list[0];
        }
        var str = substrsp(utf16_to_ucs2(post_info.content.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, '')), 0, 50);
        var title;
        var index = str.indexOf('\n');
        if (index > 0) {
            title = str.substr(0, index);
        } else {
            title = str;
        }
        var data = {
            title: get_title(),
            img: imgurl,
            des: str,
            url: get_share_url(),
            type: 'QFriend'
        }
        share_qq(data, function() {
            sendShare();
        });
    }

    // 分享到QQ空间
    function share_to_qzone() {
        var imgurl = post_info.avatar;
        if (affix_list.length > 0) {
            imgurl = affix_list[0];
        }
        var str = substrsp(utf16_to_ucs2(post_info.content.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, '')), 0, 50);
        var title;
        var index = str.indexOf('\n');
        if (index > 0) {
            title = str.substr(0, index);
        } else {
            title = str;
        }
        var data = {
            title: get_title(),
            img: imgurl,
            des: str,
            url: get_share_url(),
            type: 'QZone'
        }
        share_qq(data, function() {
            sendShare();
        });
    }

    function share_to_wb() {
        var imgurl = post_info.avatar;
        if (post_info.cover) {
            imgurl = post_info.cover;
        }
        var str = substrsp(utf16_to_ucs2(post_info.content.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, '')), 0, 50);
        var title;
        var index = str.indexOf('\n');
        if (index > 0) {
            title = str.substr(0, index);
        } else {
            title = str;
        }
        var data = {
            title: get_title(),
            thumb: imgurl,
            des: str, // + ' ' + get_share_url(),
            url: get_share_url(),
            type: 'weibo'
        }
        share_wb(data, function() {
            sendShare();
        });
    }

    function sendShare() {
        var tid = post_info.id
        sendShareDone(tid);
        api.execScript({
            name: 'win_talk_' + tid,
            script: 'setShareShow(false)'
        });
        api.closeFrame({
            name: 'talk_share',
        });
        showResult('分享成功');
    }

    window.TopicClass = function(post, type) {
        post_info = post
        post_type = type
        affix_list = post.thumb_list
    }

    window.TopicClass.prototype = {
        share_to_wb: share_to_wb,
        share_to_wechat: share_to_wechat,
        share_to_qq: share_to_qq,
        share_to_qzone: share_to_qzone,
        share_to_pengyouquan: share_to_pengyouquan,
        build_post_content: build_post_content
    }

})();

var topic_obj; // TopicClass
//var shareshow = false;
//
//function setShareShow(status) {
//    shareshow = status;
//}

var build_sys = function(str) {
    if (sys === 'android') {
        return 'icon-loading';
    } else {
        return '';
    }
}
var build_location = function(obj) {
    var loc = Convert_GCJ02_To_BD09(obj.latitude, obj.longitude);
    return 'data-lon="' + loc.lon + '" data-lat="' + loc.lat + '"';
}

//function build_post_content(str) {
//    if (str == '') {
//        return;
//    } else {
//        var s = utf16_to_ucs2(str.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
//        if (s.length > 50) {
//            s = substrsp(s, 0, 50) + '…';
//        }
//        s = s.replace(/\r\n|\n/g, '<br>');
//        return convertEmoji(s, '../../image/');
//    }
//}

// 修正JSON数据顺序错乱的问题
function fixJSON(obj) {
    var arr = obj;
    var length = arr.length;
    if (length <= 1) {
        return arr;
    }
    var arr_distance = [];
    for (var i = 0; i < length; i++) {
        var dis = parseInt(arr[i].theme.theme_addtime);
        var arr_length = arr_distance.length;
        if (arr_length == 0) {
            arr_distance.push(arr[i]);
        } else {
            for (var j = 0; j < arr_length; j++) {
                var dis_temp = parseInt(arr_distance[j].theme.theme_addtime);
                if (dis > dis_temp) {
                    arr_distance.insert(j, arr[i]);
                    break;
                } else if (j == arr_length - 1) {
                    arr_distance.push(arr[i]);
                }
            }
        }
    }
    return arr_distance;
}

var menu_show = false;
var post_list = null
var post_list_type = '' // follow mine

function togglePostMenu(index, event) {
    event.stopPropagation()
    event.preventDefault()
    index = parseInt(index)
    var post = post_list[index]
    if (post_list_type == 'mine') {
        toggleMyPostMenu(index)
    } else {
        togglePostObjMenu(post)
    }
}

function toggleMyPostMenu(index) {
    var item = post_list[index]
    var buttons = ['删除']
    api.actionSheet({
        buttons: buttons
    }, function(ret, err) {
        var buttonIndex = ret.buttonIndex;
        if (buttonIndex == 1) {
            doDelPost(item.id, function() {
                post_list.splice(index, 1)
            })
        }
    });
}

function doDelPost(id, cbk) {

    showLoading()
    ajaxGet(config.urls.delete_post, {
        post_id: id
    }, function(ret, err) {
        // var msg = ''
        hideLoading()
        if (cbk) cbk()
        showResult('删除成功')
    })
}

function togglePostObjMenu(post) {
    var buttons = ['收藏', '举报']
    if (post.is_fav) {
        buttons[0] = '取消收藏'
    }
    menu_show = true;
    api.actionSheet({
        buttons: buttons
    }, function(ret, err) {
        menu_show = false;
        var buttonIndex = ret.buttonIndex;
        if (buttonIndex == 1) {
            doPostObjFav(post)
        } else if (buttonIndex == 2) {
            doPostObjComplain(post)
        }
    });
}

function doPostFav(index) {
    var post = post_list[index]
    doPostObjFav(post)
    post_list[index] = post
}

function doPostObjFav(post) {
    ajaxGet(config.urls.fav_post, {
        id: post.id
    }, function(ret, err) {
        // var msg = ''
        showResult(ret.info)
    })
    post.is_fav = 1 - parseInt(post.is_fav)
}

function doPostComplain(index) {
    var post = post_list[index]
    doPostObjComplain(post)
}

function doPostObjComplain(post) {

    api.actionSheet({
        buttons: ['广告、诈骗', '色情内容', '违反政策法规', '人身攻击']
    }, function(ret, err) {
        menu_show = false;
        var buttonIndex = parseInt(ret.buttonIndex);
        if (buttonIndex < 5) {
            doPostComplainSubmit(post, buttonIndex)
        }
    });
}

function doPostComplainSubmit(post, buttonIndex) {

    ajaxGet(config.urls.complain_post, {
        id: post.id,
        item_id: buttonIndex
    }, function(ret, err) {
        // var msg = ''
        showResult('感谢您的举报')
    })
}

//分享话题



//分享帖子
function onPostShareClick(index, e) {
    if (e) {
        e.preventDefault();
        e.stopPropagation();
    }
    var post = post_list[index]
    sharePost(post)
}

function sharePost(post) {
    topic_obj = new TopicClass(post)
    openWin_TopicShare(post.topic_id, post.id, api.winname, api.frameName)
}

//function shareTopic(post) {
//    topic_obj = new TopicClass(post)
//    openWin_TopicShare(post.topic_id, post.id)
//}

function openMediaLinkUrl(url, e) {
    e.preventDefault();
    e.stopPropagation();
    openMediaUrl(url, '音视频')
}

function openMediaLink(index, e) {
    //if (click_allowed) {
    //}
    var link = ''
    if (index >= 0) {
        var post = post_list[index]
        link = post.media_link
    }
    e.preventDefault();
    e.stopPropagation();
    openMediaUrl(link, '音视频')
}

function onCommentClick(index, e) {
    var post = post_list[index]
    openWin_Talk(post.topic_id, post.id, '', e, 'comment');
}

function onTopicClick(index, e) {
    //if (click_allowed) {
    //}
    e.preventDefault();
    e.stopPropagation();
    var post = post_list[index]
    openWin_Club(post.topic_id, post.topic_name);
}

// 点赞/取消点赞话题

function supportPost(type, index, e) {
    e.preventDefault();
    e.stopPropagation();
    var post = post_list[index]
    supportPostObj(type, post)
    post_list[index] = post
}

function supportPostObj(type, post) {
    if (!checkLogin()) {
        return
    }
    if (post.is_support == 0) {
        post.support_num = parseInt(post.support_num) + 1
    } else {
        post.support_num = parseInt(post.support_num) - 1
    }
    post.is_support = 1 - parseInt(post.is_support)

    ajaxGet(config.urls.support, {
        type: type,
        post_id: post.id
    }, function(ret, err) {
        // var msg = ''
        //if(post.is_support) showResult('点赞成功')
        //else showResult('已取消点赞')
    })
}

function supportCommentObj(comment) {
    if (comment.is_support == 0) {
        comment.support_num = parseInt(comment.support_num) + 1
    } else {
        comment.support_num = parseInt(comment.support_num) - 1
    }
    comment.is_support = 1 - parseInt(comment.is_support)

    ajaxGet(config.urls.support_comment, {
        comment_id: comment.id
    }, function(ret, err) {
        // var msg = ''
        //if(post.is_support) showResult('点赞成功')
        //else showResult('已取消点赞')
    })
}

function favPost(type, index, e) {
    e.preventDefault();
    e.stopPropagation();
    var post = post_list[index]
    favPostObj(type, post)
    post_list[index] = post
}

function favPostObj(type, post) {
    if (!checkLogin()) {
        return
    }
    post.is_favorite = 1 - parseInt(post.is_favorite)
    ajaxGet(config.urls.fav, {
        type: type,
        id: post.id
    }, function(ret, err) {
        // var msg = ''
        //if(post.is_support) showResult('点赞成功')
        //else showResult('已取消点赞')
    })
}

// 打开图片浏览器
function openPostImageView(obj, e) {
    e.preventDefault();
    e.stopPropagation();
    openWin_ImageView(obj);
}

function showPostImg(obj) {
    var $this = $(obj);
    $this.removeClass('hidden').addClass('fadein');
}

function showPostThumb(obj) {
    var $this = $(obj);
    $this.removeClass('hidden').addClass('fadein');
    var height = $this.height();
    if (height > 250) {
        $this.css('top', -(height - 250) / 2)
    }
}

// 打开用户个人页
function openPostUserPage(mid, e) {
    e.preventDefault();
    e.stopPropagation();
    if (!checkLogin()) return
        // openWin_UserPage(mid); TODO
}

// 显示分享菜单，具体的topic_obj是在请求详情的页面创建，比如 topic_obj = new TopicClass(post_info, 'product')
function openWin_Share() {
    api.openFrame({
        name: 'topic_share',
        url: 'widget://html/topic/share.html',
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        pageParam: {
            // cid: 0,
            // tid: tid,
            framename: api.frameName,
            // type: type,
        },
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        }
    });
}
