APP = {};

window.config = {
    app_version: '1.0.0', // deprecated
    ios_version: 'formal',
    server_path: 'http://miao.appsclub.cn',
    api_path: 'http://miao.appsclub.cn/api/',

    root_path: 'http://app.maomio.com',
    root_path_old: 'http://app.maomio.com',
    source_path: 'http://app.maomio.com/mobile',
    source_path_old: 'http://app.maomio.com/mobile',
    app_download: 'http://app.maomio.com/mobile/index.php?act=app&op=download',
    max_time: 1800,
    ajax_timeout: 120,
    list_pagesize: 10
}

window.config.api_path = 'http://yixiewang.proj.com:8080/api/'
window.config.server_path = 'http://yixiewang.proj.com:8080'

window.config.api_path = 'http://yixiewang.appsclub.cn/api/'
window.config.server_path = 'http://yixiewang.appsclub.cn'

window.config.api_path = 'http://app.jiankangnp.com/api/'
window.config.server_path = 'http://app.jiankangnp.com'

window.config.urls = {
    init: config.api_path + 'common/init',
    default_index: config.api_path + 'default/index',
    get_document: config.api_path + 'common/get_document',
    banner_list: config.api_path + 'common/banner_list',
    article: config.api_path + 'content/article',
    article_detail: config.api_path + 'content/article_detail',

    login: config.api_path + 'user/login',
    sns_login: config.api_path + 'user/sns_login',
    init_push: config.api_path + 'user/init_push',
    register: config.api_path + 'user/register',
    register_enterprise: config.api_path + 'user/register_enterprise',
    register_dealer: config.api_path + 'user/register_dealer',
    upgrade_enterprise: config.api_path + 'user/upgrade_enterprise',
    upgrade_dealer: config.api_path + 'user/upgrade_dealer',
    getverifycode: config.api_path + 'user/send_sms_verify_code',
    get_user_info: config.api_path + 'user/get_user_info',
    user_edit: config.api_path + 'user/edit',
    reset_password: config.api_path + 'user/reset_password',
    modify_password: config.api_path + 'user/modify_password',
    modify_phone: config.api_path + 'user/modify_phone',
    feedback: config.api_path + 'common/feedback',
    consult: config.api_path + 'common/consult',
    activity_list: config.api_path + 'common/activity_list',
    check_unread: config.api_path + 'user/check_unread',
    favorite_list: config.api_path + 'user/favorite_list',

    save_dealer: config.api_path + 'user/save_dealer',
    my_dealer_info: config.api_path + 'user/my_dealer_info',

    upload_pic: config.server_path + '/api/upload/uppic',
    upload_delete: config.server_path + '/api/upload/delete',

    fav: config.api_path + 'common/fav',
    province_select_list: config.api_path + 'common/province_select_list',
    prod_channel_list: config.api_path + 'common/prod_channel_list',
    prod_dept_list: config.api_path + 'common/prod_dept_list',
    prod_cat_list: config.api_path + 'common/prod_cat_list',
    require_cat_list: config.api_path + 'common/require_cat_list',

    news_column_list: config.api_path + 'content/news_column_list',
    news_list: config.api_path + 'content/news_list',
    news_detail: config.api_path + 'content/news_detail',
    activity_column_list: config.api_path + 'content/activity_column_list',
    activity_list: config.api_path + 'content/activity_list',
    activity_detail: config.api_path + 'content/activity_detail',
    marketing_column_list: config.api_path + 'content/marketing_column_list',
    marketing_list: config.api_path + 'content/marketing_list',
    marketing_detail: config.api_path + 'content/marketing_detail',
    bid_area_list: config.api_path + 'content/bid_area_list',
    bid_list: config.api_path + 'content/bid_list',
    bid_detail: config.api_path + 'content/bid_detail',
    comment: config.api_path + 'content/comment',
    comment_list: config.api_path + 'content/comment_list',
    support: config.api_path + 'content/support',
    support_comment: config.api_path + 'content/support_comment',

    enterprise_list: config.api_path + 'product/enterprise_list',
    enterprise_detail: config.api_path + 'product/enterprise_detail',
    save_product: config.api_path + 'product/save_product',
    delete_product: config.api_path + 'product/delete_product',
    product_detail: config.api_path + 'product/product_detail',
    my_product_list: config.api_path + 'product/my_product_list',
    product_list: config.api_path + 'product/product_list',
    dealer_list: config.api_path + 'product/dealer_list',
    dealer_detail: config.api_path + 'product/dealer_detail',
    dealer_require_list: config.api_path + 'product/dealer_require_list',

    apply_agent: config.api_path + 'product/apply_agent',
    apply_enterprise_agent: config.api_path + 'product/apply_enterprise_agent',
    require_list: config.api_path + 'product/require_list',
    my_require_list: config.api_path + 'product/my_require_list',
    save_require: config.api_path + 'product/save_require',
    require_detail: config.api_path + 'product/require_detail',
    delete_require: config.api_path + 'product/delete_require',
    prod_set_top: config.api_path + 'product/set_top',

    post_comment: config.server_path + '/api/topic/comment',

    post_publish: config.server_path + '/api/topic/publish', // publish post
    post_list: config.server_path + '/api/topic/post_list',
    my_favorite_posts: config.server_path + '/api/topic/my_favorite_posts',
    topic_create: config.server_path + '/api/topic/create_topic',
    topic_list: config.server_path + '/api/topic/topic_list',
    my_topic_list: config.server_path + '/api/topic/my_topic_list',
    new_topic_list: config.server_path + '/api/topic/new_topic_list',
    similar_topic_list: config.server_path + '/api/topic/similar_topic_list',
    search_topic: config.server_path + '/api/topic/search_topic',
    search_user: config.server_path + '/api/topic/search_user',
    get_post_comments: config.server_path + '/api/topic/get_post_comments',
    get_post_comments_2: config.server_path + '/api/topic/get_post_comments_2',
    view_post: config.server_path + '/api/topic/view_post',
    topic_info: config.server_path + '/api/topic/topic_info',
    follow_topic: config.server_path + '/api/topic/follow_topic',
    get_topic_follow_users: config.server_path + '/api/topic/get_topic_follow_users',
    get_my_posts_supports: config.server_path + '/api/topic/get_my_posts_supports',
    get_receive_comments: config.server_path + '/api/topic/get_receive_comments',
    get_send_comments: config.server_path + '/api/topic/get_send_comments',

    fav_post: config.server_path + '/api/topic/fav_post',
    support_post: config.server_path + '/api/topic/support',
    support_comment: config.server_path + '/api/topic/support_comment',
    complain_post: config.server_path + '/api/topic/complain_post',
    complain_comment: config.server_path + '/api/topic/complain_comment',
    delete_comment: config.server_path + '/api/topic/delete_comment',
    delete_post: config.server_path + '/api/topic/delete_post',
    clear_supports: config.server_path + '/api/topic/clear_supports',

    follow: config.server_path + '/api/sns/follow',
    follow_list: config.server_path + '/api/sns/follow_list',

    message_timelines: config.server_path + '/api/message/timelines',
    talk_msg_list: config.server_path + '/api/message/talk_msg_list',
    talk_msg_refresh: config.server_path + '/api/message/talk_msg_refresh',
    talk_msg_send: config.server_path + '/api/message/talk_msg_send',
    talk_del: config.server_path + '/api/message/talk_del',

    // article_agreement: config.server_path + '/data/upload/article/post/1.html',
    article_agreement: config.server_path + '/api/default/article/i/agreement'
}

// ------------------------------------------------------------------
// ------------------------------------------------------------------
// 通用
// ------------------------------------------------------------------
// ------------------------------------------------------------------

Array.prototype.clear = function() {
    //this.length = 0;
    this.splice(0, this.length)
}
Array.prototype.addAll = function($array) {
    if ($array == null || $array.length == 0)
        return;

    for (var $i = 0; $i < $array.length; $i++)
        this.push($array[$i]);
}
Array.prototype.insert = function(index, item) {
    this.splice(index, 0, item);
}
Array.prototype.insertAll = function($array) {
    if ($array == null || $array.length == 0)
        return;
    $array = $array.reverse()
    for (var $i = 0; $i < $array.length; $i++)
        this.splice(0, 0, $array[$i]);
}

Array.prototype.remove = function(val) {
    var index = this.indexOf(val);
    while (index > -1) {
        this.splice(index, 1);
        index = this.indexOf(val);
    }
}

function clone1(obj) {
    // function Fn() {}
    // Fn.prototype = obj;
    // var o = new Fn();
    // for (var a in o) {
    //     if (typeof o[a] == "object") {
    //         o[a] = clone(o[a]);
    //     }
    // }
    // return o;
    if(typeof obj === "object") {
        if(Array.isArray(obj)) {
            var newArr = [];
            for(var i = 0; i < obj.length; i++) newArr.push(obj[i]);
            return newArr;
        } else {
            var newObj = {};
            for(var key in obj) {
                newObj[key] = clone(obj[key]);
            }
            return newObj;
        }
    } else {
        return obj;
    }
}

function clone(obj) {
  return JSON.parse(JSON.stringify(obj))
}

function emptyStr(val) {
  return val == null || val == undefined || val == ''
}

function checkScreenOrient() {
    if (window.orientation == 0 || window.orientation == 180) {
        return 0;
    } else if (window.orientation == 90 || window.orientation == -90) {
        return 1;
    }
}

function ajaxGet(url, params, callback, nohint) {
    ajaxRequest('get', url, params, callback, nohint)
}

function ajaxPost(url, params, callback, nohint) {
    ajaxRequest('post', url, params, callback, nohint)
}

function ajaxRequest(method, url, params, callback, nohint) {
    if (DEBUG) {
        log('params=' + JSON.stringify(params))
    }
    var option = {
        url: url,
        method: method,
        timeout: window.config.ajax_timeout,
        returnAll: false
    }

    if ('values' in params && params['values'] instanceof Object ||
        'files' in params && params['files'] instanceof Object) {
        option.data = params
        var login = $api.getStorage('login')
        login || (login = {
                key: ''
            }) // todo
        if (!('values' in params)) params['values'] = {}
        if (!('token' in params.values) && login != undefined) {
            params.values['token'] = login.key
        }
    } else {
        var login = $api.getStorage('login')
        login || (login = {
                key: 'abc'
            }) // todo
        if (!('token' in params) && login != undefined) {
            params['token'] = login.key
        }
        option.data = {
            values: params
        }
    }
    api.ajax(option, function(ret, err) {
        if (DEBUG) {
          log('ret=' + ret)
        }
        if (!ret) {
            log('server error url=' + url + ' ret=' + JSON.stringify(ret))
            err = '服务器异常<br>请稍后重试'
            ret = {
                data: null,
                code: -1,
                msg: err
            }
        }
        if (!nohint && ret.code != 0) showResult(ret.msg)
        if (callback) {
            callback(ret, ret.code);
            if ($) {
                $('[v-cloak]').removeAttr('v-cloak')
            }
        }
    })
}

var Paginator = function() {
    //this.scope = $scope
    this.page = 0
    this.hasmore = 0
    this.autoload = 1
    this.isloading = 0
    this.loadtimes = 0
    this.datalist = []
    this.isinsert = 0

    this.showLoadMore = 0
    this.showEmpty = 0
    this.showFail = 0
    this.showFirstLoading = 0

    this.resetPage = function() {
        this.page = 0
    }
    this.readyLoad = function() {
            if (this.isloading || this.loadtimes && !this.hasmore && this.page > 0) {
                return false
            }
            if (!this.loadtimes) {
                this.showFirstLoading = 1
            }
            return true
        }
        // 必须先处理数据后调用此方法
    this.onLoadDataComplete = function(success, result_data) {
        if (success) {
            var hasmore = !result_data.is_end_page
            if (typeof(result_data['is_end_page']) == "undefined") {
                hasmore = false
            }
            this.onLoadComplete(success, result_data.list, hasmore)
        } else {
            this.onLoadComplete(success, null, true)
        }
    }

    this.onLoadComplete = function(success, list, hasmore) {
        this.isloading = 0
        this.loadtimes++
            this.showFirstLoading = 0
        if (!success) {
            // if(this.scope) this.scope.$apply()
            return
        }
        this.hasmore = hasmore

        if (this.loadtimes > 0 && hasmore) {
            this.showLoadMore = true
        } else {
            this.showLoadMore = false
        }
        if (!list) list = []
        if (list && list.length >= 0) {
            this.page += 1
            if (this.page <= 1) {
                this.datalist.clear()
            }
            if (this.isinsert) {
                this.datalist.insertAll(list)
            } else {
                this.datalist.addAll(list)
            }
        }
        if (this.loadtimes && this.datalist.length == 0) {
            this.showEmpty = true
        } else {
            this.showEmpty = false
        }
        // if(this.scope) this.scope.$apply()
    }
}

AM = {}
AM.whenScrollBottom = function(callback) {
    $(window).scroll(function() {
        if (document.body.clientHeight + document.body.scrollTop > document.body.scrollHeight - 1) {
            callback()
        }
    })
}

AM.build_time = function(time) {
    if (time == '') return;
    var now = new Date().getTime();
    time = Math.round(now / 1000) - time;
    if (time <= 0) return '刚刚';
    var times = '';
    var years = Math.floor(time / 31104000);
    var months = Math.floor((time / 2592000) % 12);
    var days = Math.floor((time / 86400) % 30);
    var hours = Math.floor((time / 3600) % 24);
    var minutes = Math.floor((time / 60) % 60);
    time = Math.floor(time % 60);
    if (time >= 1) times = time + '秒';
    if (minutes >= 1) times = minutes + '分钟';
    if (hours >= 1) times = hours + '小时';
    if (days >= 1) times = days + '天';
    if (months >= 1) times = months + '月';
    if (years >= 1) times = years + '年';
    times += '前';
    return times;
}

// 数组插入
Array.prototype.insert = function(index, item) {
    this.splice(index, 0, item);
};

// ucs-2转utf-16（将表情图转换为实体字符）
function ucs2_to_utf16(str, clear) {
    var patt = /[\ud800-\udbff][\udc00-\udfff]/g;
    str = str.replace(patt, function(char) {
        if (clear) {
            return '';
        }
        var H, L, code;
        if (char.length === 2) {
            H = char.charCodeAt(0); // 高位
            L = char.charCodeAt(1); // 低位
            code = (H - 0xD800) * 0x400 + 0x10000 + L - 0xDC00;
            return "&#" + code + ";";
        } else {
            return char;
        }
    });
    return str;
}

// utf-16转ucs-2（将实体字符转换回表情图）
function utf16_to_ucs2(str) {
    var patt = /&#[0-9]+;/g;
    str = str.replace(/&amp;/g, '&').replace(/&amp;/g, '&').replace(/&#039;/, '\'').replace(patt, function(char) {
        var code = char.substr(2);
        code = code.substr(0, code.length - 1);
        H = Math.floor((code - 0x10000) / 0x400) + 0xD800 // 高位
        L = (code - 0x10000) % 0x400 + 0xDC00 // 低位
        return unescape('%u' + H.toString(16)) + unescape('%u' + L.toString(16));
    });
    return str;
}

// 截取字符串特殊处理（避免截断表情字符）
function substrsp(str, start, len) {
    var str = str;
    var start = start;
    var len = len;
    if (len) {
        var s1 = '';
        var s2 = '';
        if (start > 0) {
            s1 = str.substr(start - 1, 2);
        }
        if (start + len <= str.length) {
            s2 = str.substr(start + len - 1, 2);
        }
        if (/[\ud800-\udbff][\udc00-\udfff]/.test(s1)) {
            start = start - 1;
            len = len + 1;
        }
        if (/[\ud800-\udbff][\udc00-\udfff]/.test(s2)) {
            len = len + 1;
        }
        return str.substr(start, len);
    } else {
        var s1 = '';
        if (start > 0) {
            s1 = str.substr(start - 1, 2);
        }
        if (/[\ud800-\udbff][\udc00-\udfff]/.test(s1)) {
            start = start - 1;
        }
        return str.substr(start);
    }
}

// 引导页记录
function set_guide(key, value) {
    var guide = $api.getStorage('guide');
    if (guide == null) {
        guide = {
            'top': true, // 首页
            'weather1': true, // 天气页1
            'weather2': true, // 天气页2
            'report': true, // 发布新话题页
            'club': true, // 窝子首页
            'club_detail': true, // 窝子详情页
            'userspace': true // 个人中心页
        }
        guide[key] = value;
    } else if (guide[key] == null) {
        guide = $.extend(guide, eval('({"' + key + '": ' + value + '})'));
    } else {
        guide[key] = value;
    }
    $api.setStorage('guide', guide);
}

// 滑动中触屏事件处理（禁止单击事件）
var click_allowed = true;

function scroll_click(systype) {
    if (systype == 'android') {
        var scroll_timer = 0;
        $(window).on('scroll', function() {
            scroll_timer = scroll_timer + 1;
            var scroll_timer_temp = scroll_timer;
            click_allowed = false;
            setTimeout(function() {
                if (scroll_timer_temp == scroll_timer) {
                    click_allowed = true;
                }
            }, 150);
        }).on('touchstart', function(e) {
            scroll_timer = 0;
            if (!click_allowed) {
                setTimeout(function() {
                    click_allowed = true;
                }, 150);
            }
        })
    } else {
        var scroll_top = 0;
        $(window).on('scroll', function() {
            click_allowed = true;
        }).on('touchmove', function() {
            click_allowed = false;
            scroll_top = $(window).scrollTop();
        }).on('touchend', function() {
            if (scroll_top == $(window).scrollTop()) {
                click_allowed = true;
            }
        })
    }
}

// 下载图片文件
function downloadImage(url, path, cbk, err) {
    var name = url.substr(url.lastIndexOf('/') + 1);
    if (name.lastIndexOf('.') < name.lastIndexOf('@')) {
        name = name.substr(0, name.lastIndexOf('@'));
    }
    var download_name = path + name;
    api.download({
        url: url,
        cache: true,
        savePath: download_name
    }, function(ret) {
        if (ret && ret.state == 1 && cbk) {
            cbk(download_name);
        } else if (err) {
            err();
        }
    });
}

// 压缩图片文件
function compressImg(obj, cbk, err_cbk) {
    var qulity = 0.8;
    var target_w = 720;
    if (obj.qulity != null) {
        qulity = obj.qulity;
    }
    if (obj.width != null) {
        target_w = obj.width;
    }
    var index = obj.src.lastIndexOf('.')
    var ext = obj.src.substring(index)
    ext = '.jpg'
    console.log('imageFilter...')
    var imageFilter = api.require("imageFilter");
    console.log('imageFilter=' + imageFilter)
    imageFilter.getAttr({
        path: obj.src
    }, function(ret, err) {
        console.log('imageFilter.getAttr err=' + err + ' ret=' + JSON.stringify(ret))
        if (ret.status) {
            var original_w = ret.width;
            var original_h = ret.height;
            if (ext == '.gif') {
                cbk(obj.src, obj.id);
                return
            }
            var imgDir = api.cacheDir + '/upload/'
            var imgName = obj.id + ext
            var imgPath = imgDir + imgName
            if (original_w <= target_w) {
                imageFilter.compress({
                    img: obj.src,
                    quality: qulity,
                    scale: 1,
                    save: {
                        album: false,
                        imgPath: imgDir,
                        imgName: imgName
                    }
                }, function(ret, err) {
                    if (ret.status && cbk) {
                        cbk(imgPath, obj.id);
                    } else if (!ret.status && err_cbk) {
                        err_cbk(err);
                    }
                });
            } else if (original_w > target_w) {
                var scale = target_w / original_w;
                imageFilter.compress({
                    img: obj.src,
                    quality: qulity,
                    scale: scale,
                    save: {
                        album: false,
                        imgPath: imgDir,
                        imgName: imgName
                    }
                }, function(ret, err) {
                    if (ret.status && cbk) {
                        cbk(imgPath, obj.id);
                    } else if (!ret.status && err_cbk) {
                        err_cbk(err);
                    }
                });
            }
        } else if (err_cbk) {
            err_cbk(err);
        }
    });
}

// lazyload首屏不滑动时无法触发事件的补足
function lazyload_fix(obj, num, img_num) {
    var $this = $(obj);
    var length = $this.length;
    if (length > num) {
        length = num;
    }
    for (var i = 0; i < length; i++) {
        if (img_num) {
            for (var j = 0; j < img_num; j++) {
                var $img = $this.eq(i).find('.img-item img').eq(j);
                $img.attr('src', $img.data('original'));
            }
        } else {
            $this.eq(i).find('.img-item img').each(function() {
                var $img = $(this);
                $img.attr('src', $img.data('original'));
            });
        }
    }
}

// 检查用户是否已登录
function checkLogin(winname) {
    if (is_browser) return true
    var login = $api.getStorage('login');
    if (login && login.key) {
        return true;
    } else {
        openWin_Login(winname);
        return false;
    }
}

function getLoginUserInfo() { // 用户id : id
    return $api.getStorage('userinfo').data
}

var getLoginKey = function() {
    var login = $api.getStorage('login')
    if (login == null) return null
    return login.key
}

function refreshUserSpace() {
    api.execScript({
        name: 'root',
        frameName: 'userspace',
        script: 'refresh()'
    });
}

// GCJ02坐标转BD09坐标（腾讯地图坐标转百度地图坐标）
function Convert_GCJ02_To_BD09(lat, lon) {
    var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
    var x = parseFloat(lon);
    var y = parseFloat(lat);
    var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * x_pi);
    var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * x_pi);
    var lon = z * Math.cos(theta) + 0.0065;
    var lat = z * Math.sin(theta) + 0.006;
    return {
        lat: lat,
        lon: lon
    };
}

// BD09坐标转GCJ02坐标（百度地图坐标转腾讯地图坐标）
function Convert_BD09_To_GCJ02(lat, lon) {
    var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
    var x = parseFloat(lon) - 0.0065;
    var y = parseFloat(lat) - 0.006;
    var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);
    var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);
    var lon = z * Math.cos(theta);
    var lat = z * Math.sin(theta);
    return {
        lat: lat,
        lon: lon
    };
}

// 获取地理位置 40.027614,116.312256
function getPosition(cbk, err, timer) {
    var sta = 1;
    var lat = 40.027614;
    var lon = 116.312256;
    var t = 0;
    if (sta) {
        var location = {
            lat: lat,
            lon: lon
        }
        var location_now = $api.getStorage('location');
        if (location_now == null || !location_now) {
            $api.setStorage('location', location);
        } else {
            location_now.lat = lat;
            location_now.lon = lon;
            $api.setStorage('location', location_now);
        }

        if ($api.getStorage('login') != null && $api.getStorage('login').key) {
            var loc = Convert_BD09_To_GCJ02(lat, lon);
            api.ajax({
                url: window.config.source_path + '/index.php?act=member_info&op=update_location',
                method: 'post',
                data: {
                    values: {
                        key: $api.getStorage('login').key,
                        lat: loc.lat,
                        lng: loc.lon
                    }
                },
                timeout: window.config.ajax_timeout,
                returnAll: false
            });
        }
        if (cbk) {
            cbk(lat, lon);
        }
    }
}

var att_time;
// 操作成功提示
function showSuccess(str) {
    att_time = new Date().getTime();
    var $att_layer = $('#att-layer');
    var $att_box = $('#att-txt-box');
    $att_layer.removeClass();
    $att_box.html(str);
    $att_layer.addClass('fadein success show');
    setTimeout(function() {
        var time_now = new Date().getTime();
        if (time_now - att_time >= 2600) {
            $att_layer.addClass('fadeout');
            setTimeout(function() {
                time_now = new Date().getTime();
                if (time_now - att_time >= 3200) {
                    $att_layer.removeClass();
                }
            }, 600);
        }
    }, 2600);
}

// 错误提示
function showError(str) {
    att_time = new Date().getTime();
    var $att_layer = $('#att-layer');
    var $att_box = $('#att-txt-box');
    $att_layer.removeClass();
    $att_box.html(str);
    $att_layer.addClass('fadein error show');
    setTimeout(function() {
        var time_now = new Date().getTime();
        if (time_now - att_time >= 2600) {
            $att_layer.addClass('fadeout');
            setTimeout(function() {
                time_now = new Date().getTime();
                if (time_now - att_time >= 3200) {
                    $att_layer.removeClass();
                }
            }, 600);
        }
    }, 2600);
}

// 气泡提示
function toast(str, loc) {
    var location = loc ? loc : 'middle';
    api.toast({
        msg: str,
        duration: 2000,
        location: location
    });
}

// 动态加载CSS文件
function loadCSS(href) {
    var nodes = document.getElementsByTagName('link');
    var temp_href = href.substr(0, href.lastIndexOf('.css') + 4);
    var link = document.createElement('link');
    link.type = 'text/css';
    link.rel = 'stylesheet';
    link.href = href;
    for (var i = nodes.length; i >= 0; i--) {
        var node = nodes[i];
        if (node && node.getAttribute('href') != null && node.getAttribute('href').indexOf(temp_href) > -1) {
            node.parentNode.replaceChild(link, node);
            return;
        }
    }
    document.getElementsByTagName("head")[0].appendChild(link);
}

function showNavigationBar(y, itemTitles, selectedIndex, callback, showScrollIndicator, itemWidth) {
    if (itemTitles.length == 0) return null
    height = 42
    showScrollIndicator = false
        //if(itemTitles.length >=5) showScrollIndicator = true
    if (!itemWidth) {
        itemWidth = api.winWidth / itemTitles.length
            // if (itemWidth >= 80 || itemWidth < 60) {
        if (itemWidth < 90) {
            itemWidth = 90
                //showScrollIndicator = true
        }
    }
    var navigationBar = api.require('navigationBar');
    items = []
    itemTitles.forEach(function(title) {
        items.push({
            title: title,
            bg: '#ffffff',
            bgSelected: '#ffffff'
        })
    })
    navigationBar.open({
        y: y,
        w: api.winWidth,
        h: height,
        itemSize: {
            w: itemWidth
        },
        selectedIndex: selectedIndex,
        selectedLine: {
            color: '#139ce8', // 字符串；下划线的颜色
            width: 3, // 数字；下划线的宽度
            marginLR: 8, // 数字；相对于整个item左右边距
        },
        items: items,
        font: {
            size: 16, //（可选项）数字类型；导航项字体大小；默认：14
            sizeSelected: 16,
            color: '#666',
            colorSelected: '#139ce8',
        },
        fixedOn: api.frameName,
        showScrollIndicator: showScrollIndicator
    }, function(ret, err) {
        if (callback) callback(ret, err)
            // if (ret) {
            //     alert(JSON.stringify(ret));
            // } else {
            //     alert(JSON.stringify(err));
            // }
    });
    return navigationBar
}

// ------------------------------------------------------------------
// ------------------------------------------------------------------
// QQ、微信相关
// ------------------------------------------------------------------
// ------------------------------------------------------------------

// QQ登录（绑定）
function login_qq(cbk, error) {
    var obj_qq = api.require('qq');
    obj_qq.login(function(ret, err) {
        if (ret.status) {
            if (cbk) {
                cbk(ret);
            } else {
                hideLoading();
            }
        } else if (error) {
            error(err.msg);
        }
    });
}

// 微信登录（绑定）
function login_wechat(cbk, error) {
    var obj_wx = api.require('wx');
    obj_wx.auth({}, function(ret, err) {
        if (ret.status) {
            obj_wx.getToken({
                code: ret.code
            }, function(ret, err) {
                if (ret.status && cbk) {
                    cbk(ret);
                } else {
                    var code = err.code;
                    if (code == -1) {
                        showResult('未知错误');
                    } else if (code == 4) {
                        showResult('网络超时');
                    } else {
                        showResult('登录失败');
                    }
                }
            });
        } else if (error) {
            error(err.code);
        }
    });
}

function login_weibo(cbk, error) {
    var weibo = api.require('weibo');
    weibo.isInstalled(
        function() {}
    )
    weibo.auth(function(ret, err) {
        //alert(JSON.stringify(ret))
        if (ret.status) {
            if (cbk) {
                cbk(ret);
            } else {
                hideLoading();
            }
        } else if (error) {
            error(err.msg);
        }
    });
}

function login_weibo2(cbk, error) {
    var weibo = api.require('sinaWeiBo');
    //weibo.isInstalled(
    //    function(ret) {
    //        if (ret.status) {
    //            alert('已安装新浪微博客户端');
    //        } else {
    //            alert('未安装新浪微博客户端');
    //        }
    //    }
    //);
    //weibo.auth({apiKey: '2028755848', registUrl: 'http://www.appsclub.cn'}, function(ret,err){
    weibo.auth(function(ret, err) {
        // alert(JSON.stringify(ret))
        if (ret.status) {
            if (cbk) {
                cbk(ret);
            } else {
                hideLoading();
            }
        } else if (error) {
            error(err.msg);
        }
    });
}

// QQ分享
function share_qq(opt, cbk) {
    var obj_qq = api.require('qq');
    var data = {
        title: opt.title,
        imgUrl: opt.img,
        description: opt.des,
        url: opt.url,
        type: opt.type
    }
    obj_qq.shareNews(data, function(ret, err) {
        if (ret.status && cbk) {
            cbk();
        } else {
            var code = err.code;
            if (code == 10000 || code == 10001) {
                showResult('发送失败');
            } else if (code == 10009) {
                showResult('当前设备未安装QQ客户端');
            }
        }
    });
}

// 微信分享（第一步）
function share_wechat(opt, cbk) {
    var obj_wx = api.require('wx');
    var data = {
        scene: opt.scene,
        title: opt.title,
        description: opt.des,
        contentUrl: opt.url
    }
    if (opt.thumb != null && opt.thumb != '') {
        var thumb = opt.thumb;
        console.log(thumb)
        if (thumb.indexOf('http') == 0) {

            console.log('downloadImage...' + thumb)
            downloadImage(thumb, api.cacheDir + '/share_img/', function(path) {

                if (api.systemType == 'ios' || api.systemType == 'android') {
                    thumb = 'widget://res/logo.png'
                        // 压缩图片
                    var imageFilter = api.require("imageFilter");
                    var imgDir = api.cacheDir + '/share_img/'
                    var imgName = 'share_temp.jpg'
                    var imgFile = imgDir + imgName
                    console.log('compress image...' + path + '----' + imgFile)
                    imageFilter.compress({
                        img: path,
                        quality: 0.9,
                        size: {
                            w: 80,
                            h: 80
                        },
                        save: {
                            album: false,
                            imgPath: imgDir,
                            imgName: imgName
                        }
                    }, function(ret, err) {
                        console.log('compress image finish...' + JSON.stringify(ret))
                        thumb = imgFile
                            //if (ret.status) {
                            //    //cbk(imgPath, obj.id);
                            //    imageFilter.getAttr({
                            //        path: imgFile
                            //    }, function(ret, err) {
                            //        if (ret.status) {
                            //            console.log(JSON.stringify(ret));
                            //            if(ret.size < 30000) {
                            //                thumb = imgFile
                            //            }
                            //        } else {
                            //            console.log(JSON.stringify(err));
                            //        }
                            //    });
                            //}
                        data = $.extend(data, {
                            thumb: thumb
                        });
                        share_wechat_act(obj_wx, data, cbk);
                    });
                    return
                }

                data = $.extend(data, {
                    thumb: path
                })
                share_wechat_act(obj_wx, data, cbk);
            }, function() {
                data = $.extend(data, {
                    thumb: 'widget://res/logo.png'
                })
                share_wechat_act(obj_wx, data, cbk);
            });
        } else {
            data = $.extend(data, {
                thumb: thumb
            });
            share_wechat_act(obj_wx, data, cbk);
        }
    } else {
        share_wechat_act(obj_wx, data, cbk);
    }
}

// 微信分享（第二步）
function share_wechat_act(obj_wx, data, cbk) {
    log('share_wechat_act data=' + JSON.stringify(data))
    obj_wx.shareWebpage(data, function(ret, err) {
        log('share_wechat_act ret=' + JSON.stringify(ret))
        if (ret.status && cbk) {
            cbk();
        } else {
            var code = err.code;
            if (code == -1) {
                showResult('发生错误:' + JSON.stringify(err));
            } else if (code == 3) {
                showResult('发送失败');
            } else if (code == 4) {
                showResult('授权拒绝');
            } else if (code == 6) {
                showResult('当前设备未安装微信客户端');
            }
        }
    });
}

function share_wb(opt, cbk) {
    var shareobj = api.require('weibo');
    var data = {
        text: opt.des,
        title: opt.title,
        description: opt.des,
        thumb: 'widget://res/logo.png',
        contentUrl: opt.url
    }
    if (opt.thumb != null && opt.thumb != '') {
        var thumb = opt.thumb;
        console.log(thumb)
        if (thumb.indexOf('http') == 0) {

            console.log('downloadImage...' + thumb)
            downloadImage(thumb, api.cacheDir + '/share_img/', function(path) {

                if (api.systemType == 'ios') {
                    thumb = 'widget://res/logo.png'
                        // 压缩图片
                    var imageFilter = api.require("imageFilter");
                    var imgDir = api.cacheDir + '/share_img/'
                    var imgName = 'share_temp.jpg'
                    var imgFile = imgDir + imgName
                    console.log('compress image...' + path + '----' + imgFile)
                    imageFilter.compress({
                        img: path,
                        quality: 0.9,
                        size: {
                            w: 80,
                            h: 80
                        },
                        save: {
                            album: false,
                            imgPath: imgDir,
                            imgName: imgName
                        }
                    }, function(ret, err) {
                        console.log('compress image finish...' + JSON.stringify(ret))
                        thumb = imgFile
                        data = $.extend(data, {
                            thumb: thumb
                        });
                        share_wb_act(shareobj, data, cbk);
                    });
                    return
                }
                data = $.extend(data, {
                    thumb: path
                })
                share_wb_act(shareobj, data, cbk);
            }, function() {
                data = $.extend(data, {
                    thumb: 'widget://res/logo.png'
                })
                share_wb_act(shareobj, data, cbk);
            });
        } else {
            data = $.extend(data, {
                thumb: thumb
            });
            share_wb_act(shareobj, data, cbk);
        }
    } else {
        share_wb_act(shareobj, data, cbk);
    }
}

function share_wb_act(shareobj, data, cbk) {
    shareobj.shareWebPage(data, function(ret, err) {
        if (ret.status && cbk) {
            cbk();
        } else {
            var code = err.code;
            //showResult('发送失败');
        }
    });
}

function share_wb2(opt, cbk) {
    var obj = api.require('sinaWeiBo');
    var data = {
        contentType: 'text',
        imageUrl: opt.img,
        text: opt.des,
        url: opt.url,
        media: {
            title: opt.title,
            description: opt.des,
            thumbUrl: opt.img,
            webpageUrl: opt.url
        }
    }
    obj.auth({
        isAuth: false
    }, function() {
        obj.sendRequest(data, function(ret, err) {
            //alert(JSON.stringify(ret))
            if (ret.status && cbk) {
                cbk();
            } else {
                var code = err.code;
                //showResult('发送失败');
            }
        });
    })

}

// ------------------------------------------------------------------
// ------------------------------------------------------------------
// 与服务器数据交互
// ------------------------------------------------------------------
// ------------------------------------------------------------------

// 获取服务器当前时间戳
function getSeverTime(cbk, err) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=common&op=getservicetime',
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                return;
            }
            if (cbk) {
                cbk(data);
            }
        } else if (err) {
            err();
        }
    });
}

// 向服务器告知用户的分享行为
function sendShareDone(tid) {
    var login = $api.getStorage('login');
    if (login != null && login.key) {
        api.ajax({
            url: window.config.source_path + '/index.php?act=theme&op=share&key=' + login.key + '&t_id=' + tid,
            method: 'get',
            timeout: window.config.ajax_timeout,
            returnAll: false
        }, function(ret, err) {
            if (ret) {
                var data = ret.datas;
                if (data.hasOwnProperty('error')) {
                    return;
                }
            }
        });
    }
}

// 获取用户的任务进度
function getQuestRate(cbk, err) {
    api.ajax({
        url: source_path + '/index.php?act=task&op=get_progress&key=' + $api.getStorage('login').key,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret && cbk) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                return;
            }
            cbk(data);
        } else if (err) {
            err();
        }
    });
}

/**
 * 获取登录用户信息
 */
function getUserInfo(key, cbk, err_cbk) {
    var params = {}
    if(key) params['token'] = key
    ajaxGet(config.urls.get_user_info, params, function(ret, ec) {
        if (ec) {
            log('getUserInfo err=' + ret.info)
            $('#btn-submit').removeClass('sending');
            $api.rmStorage('login');
            if (err_cbk) err_cbk();
        }
        log('getUserInfo ' + JSON.stringify(ret.data))
        if (cbk) {
            $api.setStorage('userinfo', {
                date: new Date().getTime(),
                data: ret.data
            });
            cbk(ret.data);
        }
    })
}

//function getUserInfo(key, cbk, err) {
//  api.ajax({
//    url: window.config.source_path + '/index.php?act=member_info&op=get_userinfo',
//    method: 'post',
//    timeout: window.config.ajax_timeout,
//    data: {
//      values: {
//        key: key
//      }
//    },
//    returnAll: false
//  },function(ret){
//    if (ret) {
//      var data = ret.datas;
//      if (data.hasOwnProperty('error')) {
//        if (err && ret.hasOwnProperty('login') && ret.login == 0) {
//          err(true);
//          return;
//        } else {
//          showResult(data.error);
//          return;
//        }
//      }
//      if (cbk) {
//        $api.setStorage('userinfo', {
//          date: new Date().getTime(),
//          data: data
//        });
//        cbk(data);
//      }
//    } else if (err) {
//      err();
//    }
//  });
//}

// 获取其他用户信息
function getOtherUserInfo(mid, cbk, err_cbk) {
    if (!/^[0-9]+$/.test(mid) && err_cbk) {
        err_cbk();
        return;
    }
    ajaxGet(config.urls.get_user_info, {
        uid: mid
    }, function(ret, ec) {
        if (ec) {
            if (err_cbk) err_cbk();
            return
        }
        if (cbk) {
            cbk(ret.data);
        }
    })
}

var msg_loading = false;
// 获取APP未读消息
function getMsgNumber_app(cbk) {
    if (msg_loading) {
        return;
    }
    msg_loading = true;
    api.ajax({
        url: window.config.source_path + '/index.php?act=member_message&op=message_polling&key=' + $api.getStorage('login').key,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                msg_loading = false;
                return;
            }
            var num_sum = 0;
            var num_sys = parseInt(data.sysmessage.countnum);
            var num_like = parseInt(data.goodpost.countnum);
            var num_reply = parseInt(data.reply.countnum);
            var num_fishmsg = parseInt(data.fishmsg.countnum);
            num_sum = num_sum + num_sys + num_like + num_reply + num_fishmsg;
            msg_loading = false;
            if (cbk) {
                cbk({
                    sum: num_sum,
                    sys: data.sysmessage,
                    like: data.goodpost,
                    reply: data.reply,
                    fishmsg: data.fishmsg
                })
            }
        } else {
            msg_loading = false;
        }
    });
}
var msg_listening = false;
var msg_source;
// 开始监听APP未读消息
function listenMsgNumber_app(cbk) {
    if (msg_listening) {
        return;
    }
    msg_listening = true;
    msg_source = new EventSource(window.config.source_path + '/index.php?act=member_message&op=message&key=' + $api.getStorage('login').key);
    msg_source.onmessage = function(event) {
        var data = JSON.parse(event.data);
        if (data.hasOwnProperty('datas')) {
            data = data.datas;
            var num_sum = 0;
            var num_sys = parseInt(data.sysmessage.countnum);
            var num_like = parseInt(data.goodpost.countnum);
            var num_reply = parseInt(data.reply.countnum);
            var num_fishmsg = parseInt(data.fishmsg.countnum);
            num_sum = num_sum + num_sys + num_like + num_reply + num_fishmsg;
            if (cbk) {
                cbk({
                    sum: num_sum,
                    sys: data.sysmessage,
                    like: data.goodpost,
                    reply: data.reply,
                    fishmsg: data.fishmsg
                })
            }
        }
    };
}

// 停止监听APP未读消息
function stopListenMsgNumber_app() {
    if (msg_source) {
        msg_source.close();
        msg_listening = false;
    }
}

// 获取聊天未读消息数
function getMsgNumber_chat(rongcloud, cbk) {
    rongcloud.getConversationList(function(ret, err) {
        if (ret.status == 'success') {
            var list = ret.result;
            var length = list.length;
            var num = 0;
            var $parent = $('<div></div>');
            if ($api.getStorage('userinfo') != null && $api.getStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id) != null) {
                $parent = $('<div>' + $api.getStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id) + '</div>');
            }
            for (var i = 0; i < length; i++) {
                if (list[i].senderUserId != $api.getStorage('userinfo').data.member_id && list[i].receivedStatus == 'UNREAD') {
                    var $node = $parent.find('#chat-' + list[i].targetId);
                    if ($node.length == 1 && $node.find('.date').data('value') != list[i].sentTime) {
                        num = num + 1;
                    } else if (list[i].unreadMessageCount > 0) {
                        num = num + 1;
                    }
                }
            }
            if (cbk) {
                cbk(num, JSON.stringify(ret));
            }
        } else if (cbk) {
            cbk(0, '{result:[]}');
        }
    })
}

// 钓场报错
function report_Place(opt, cbk, err) {
    var dt = $.extend({
        key: $api.getStorage('login').key
    }, opt);
    api.ajax({
        url: window.config.source_path + '/index.php?act=fishplace&op=add_error',
        method: 'post',
        data: {
            values: dt
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err('信息提交失败<br>请稍后重试');
        }
    });
}

// 点赞话题
function likeTalk(opt, cbk, err) {
    var data = '&key=' + $api.getStorage('login').key + '&c_id=' + opt.cid + '&t_id=' + opt.tid;
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=ajax_likeyes' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                if (data.error != '0') {
                    showResult(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err();
        }
    });
}

// 取消点赞话题
function dislikeTalk(opt, cbk, err) {
    var data = '&key=' + $api.getStorage('login').key + '&c_id=' + opt.cid + '&t_id=' + opt.tid;
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=ajax_likeno' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                if (data.error != '0') {
                    showResult(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err();
        }
    });
}

// 举报话题/回复
function reportTalk(opt, cbk) {
    var dt = '&key=' + $api.getStorage('login').key + '&c_id=' + opt.cid + '&t_id=' + opt.tid;
    if (opt.rid != null && opt.rid) {
        dt = dt + '&r_id=' + opt.rid;
    }
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme_inform&op=index' + dt,
        method: 'post',
        data: {
            values: {
                content: opt.content
            }
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (data.error == '0') {
                    showResult('不能重复举报');
                } else {
                    showResult(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else {
            showResult('服务器异常<br>请稍后重试');
            return;
        }
    });
}

// 举报图片
function reportImage(opt, cbk) {
    var values = {
        key: $api.getStorage('login').key,
        affix_id: opt.id,
        content: opt.content
    }
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme_inform&op=report_affix',
        method: 'post',
        data: {
            values: values
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (data.error == '0') {
                    showResult('不能重复举报');
                } else {
                    showResult(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else {
            showResult('服务器异常<br>请稍后重试');
            return;
        }
    });
}

// 删除话题
function deleteTalk(opt, cbk) {
    var data = '&key=' + $api.getStorage('login').key + '&c_id=' + opt.cid + '&t_id=' + opt.tid;
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=del_theme' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk();
            }
        } else {
            showResult('服务器异常<br>请稍后重试');
            return;
        }
    });
}

// 删除回复
function deleteReply(opt, cbk) {
    var data = '&key=' + $api.getStorage('login').key + '&c_id=' + opt.cid + '&t_id=' + opt.tid + '&r_id=' + opt.rid;
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=del_reply' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk();
            }
        } else {
            showResult('服务器异常<br>请稍后重试');
            return;
        }
    });
}

// 收藏话题
function manageFavorite(opt, cbk, err) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=favorite&op=add_favorite',
        method: 'post',
        data: {
            values: opt
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err('收藏失败<br>请稍后重试');
        }
    });
}


// 取消收藏
function manageFavorite_cancel(opt, cbk, err) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=favorite&op=del_favorite',
        method: 'post',
        data: {
            values: opt
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err(data.error);
                }
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err('取消收藏失败<br>请稍后重试');
        }
    });
}

// 管理话题
function manageTalk(opt, cbk) {
    var data = '&key=' + $api.getStorage('login').key + '&id=' + opt.tid;
    var values = {};
    if (opt.cid == '') {
        data = data + '&column=' + opt.column + '&value=' + opt.value;
        if (opt.tips != null) {
            data = data + '&tips=' + opt.tips;
        }
    } else {
        values = {
            c_id: opt.cid,
            c_name: opt.cname
        }
    }
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=ajax' + data,
        method: 'post',
        data: {
            values: values
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk();
            }
        } else {
            showResult('服务器异常<br>请稍后重试');
            return;
        }
    });
}

// 窝子签到
function signClub(cid, cbk, err) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=circle&op=sign&key=' + $api.getStorage('login').key + '&c_id=' + cid,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk(ret);
            }
        } else if (err) {
            err();
        }
    });
}

// 关注窝子
function followClub(cid, cbk, err) {
    var data = '&key=' + $api.getStorage('login').key + '&c_id=' + cid;
    api.ajax({
        url: window.config.source_path + '/index.php?act=group&op=apply' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk(ret);
            }
        } else if (err) {
            err();
        }
    });
}

// 取消关注窝子
function unfollowClub(cid, cbk, err) {
    var data = '&key=' + $api.getStorage('login').key + '&c_id=' + cid;
    api.ajax({
        url: window.config.source_path + '/index.php?act=group&op=quit' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err();
        }
    });
}

// 关注钓友
function followPeople(mid, cbk, err) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=sns_friend&op=addfollow&member_id=' + mid,
        method: 'post',
        data: {
            values: {
                key: $api.getStorage('login').key
            }
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk(ret);
            }
        } else if (err) {
            err();
        }
    });
}

// 取消关注钓友
function unfollowPeople(mid, cbk, err) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=sns_friend&op=delfollow&member_id=' + mid,
        method: 'post',
        data: {
            values: {
                key: $api.getStorage('login').key
            }
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                if (err) {
                    err();
                }
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk();
            }
        } else if (err) {
            err();
        }
    });
}

// 获取点赞话题的用户列表
function getLikeList(cid, tid, cbk) {
    var data = '&c_id=' + cid + '&t_id=' + tid;
    var login = $api.getStorage('login');
    if (login && login.key) {
        data = data + '&key=' + login.key;
    }
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=like_member' + data,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                showResult(data.error);
                return;
            }
            if (cbk) {
                cbk(data);
            }
        } else {
            showResult('服务器异常<br>请稍后重试');
            return;
        }
    });
}

// 清除APP未读消息数
function clearMsg(type, cbk) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=member_message&op=clear_message&key=' + $api.getStorage('login').key + '&message_type=' + type,
        method: 'get',
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret, err) {
        if (ret) {
            var data = ret.datas;
            if (data.hasOwnProperty('error')) {
                return;
            }
            if (cbk) {
                cbk();
            }
        }
    });
}

// 发送渔汛后推送消息
function sendFishmsg(tid) {
    api.ajax({
        url: window.config.source_path + '/index.php?act=theme&op=push_fishmsg&t_id=' + tid,
        method: 'post',
        data: {
            values: {
                key: $api.getStorage('login').key
            }
        },
        timeout: window.config.ajax_timeout,
        returnAll: false
    }, function(ret) {});
}

// 发送急问后推送消息
function sendQuestion(tid) {
    if (typeof(EventSource) === "undefined") {
        return;
    }
    var source = new EventSource(window.config.source_path + '/index.php?act=theme&op=push_qamsg&t_id=' + tid + '&key=' + $api.getStorage('login').key);
    var timer = 1;
    source.onmessage = function(event) {
        var data = JSON.parse(event.data);
        if (data.datas == 1) {
            source.close();
        }
    };
    source.onerror = function() {
        timer = timer - 1;
        if (timer <= 0) {
            source.close();
        }
    };
}

// 获取融云用户Token
function getToken_RongCloud(cbk, err) {
    if ($api.getStorage('login') != null && $api.getStorage('login').key) {
        api.ajax({
            url: window.config.source_path + '/index.php?act=im&op=get_token&key=' + $api.getStorage('login').key,
            method: 'get',
            timeout: window.config.ajax_timeout,
            returnAll: false
        }, function(ret) {
            if (ret) {
                var data = ret.datas;
                if (data.hasOwnProperty('error')) {
                    if (err) {
                        err();
                    }
                    return;
                }
                if (cbk) {
                    cbk(data.token);
                }
            } else if (err) {
                err();
            }
        });
    }
}

// ------------------------------------------------------------------
// ------------------------------------------------------------------
// 创建新页面
// ------------------------------------------------------------------
// ------------------------------------------------------------------

function am_openWin(winname, url, pageParam) {
    api_openWin({
        name: winname,
        url: 'widget://html/' + url,
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        softInputMode: 'pan',
        pageParam: pageParam
    });
}

// 打开登录页面
function openWin_Login(winname) {
    api_openWin({
        name: 'win_login',
        url: 'widget://html/user/login.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        softInputMode: 'pan',
        pageParam: {
            winname: winname
        }
    });
}

// 打开注册页面
function openWin_Register(winname) {
    api_openWin({
        name: 'win_register',
        url: 'widget://html/user/register.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        softInputMode: 'pan',
        pageParam: {
            winname: winname
        }
    });
}

///**
// * 打开发帖页面
// * @param winname
// */
//function openWin_NewPost(winname) {
//    if (!checkLogin(winname)) {
//        return
//    }
//    api.openWin({
//        name: 'win_new_post',
//        url: 'widget://html/club/create.html',
//        bounces: false,
//        vScrollBarEnabled: false,
//        hScrollBarEnabled: false,
//        slidBackEnabled: true,
//        pageParam: {
//            step: 1,
//            name: ''
//        }
//    });
//}

// 打开帖子详情页
function openWin_Talk(cid, tid, ex, event, from) {
    log('openWin_Talk cid=' + cid)
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/view_post.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: cid,
            tid: theme_id,
            extra: extra,
            from: from
        }
    });
}

// 打开帖子详情页
function openWin_NewsDetail(cid, tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/news_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: cid,
            tid: theme_id,
            extra: extra,
            from: from
        }
    });
}

// 打开约钓详情页
function openWin_Travel(tid, ex) {
    var travel_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_travel_detail_' + travel_id,
        url: 'widget://html/travel/detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            travel_id: travel_id,
            extra: extra
        }
    });
}

// 打开话题帖子列表页面
function openWin_Club(cid, cname, win, from) {
    var club_id = cid ? cid : 0;
    var winname = win ? win : '';
    api_openWin({
        name: 'win_topic' + club_id,
        url: 'widget://html/topic/post_list.html',
        //url: 'widget://html/club/detail.html',
        bounces: false,
        vScrollBarEnabled: true,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            cid: club_id,
            name: cname,
            winname: winname
        },
        reload: true
    });
}

// 打开话题详情
function openWin_ClubDetail(cid, cname, win) {
    var club_id = cid ? cid : 0;
    var winname = win ? win : '';
    api_openWin({
        name: 'win_club_info_' + club_id,
        url: 'widget://html/topic/topic_info.html',
        bounces: false,
        vScrollBarEnabled: true,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            cid: club_id,
            cname: cname,
            winname: winname
        },
        reload: true
    });
}

// 打开消息页
function openWin_message(cid, cname, win) {
    var id = cid ? cid : 0;
    var winname = win ? win : '';
    api_openWin({
        name: 'win_club_detail_' + id,
        url: 'widget://html/message/index.html',
        bounces: false,
        vScrollBarEnabled: true,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            cid: id,
            cname: cname,
            winname: winname
        },
        reload: true
    });
}

// 打开钓场详情面
function openWin_Place(pid, pname) {
    api_openWin({
        name: 'win_place_detail',
        url: 'widget://html/top/place_detail.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            pid: pid,
            pname: pname ? pname : ''
        },
        reload: true
    });
}

// 打开商品详情页
function openWin_Item(item_id, group_id) {
    var gid = '';
    if (group_id != null) {
        gid = group_id;
    }
    api_openWin({
        name: 'win_buy_item',
        url: 'widget://html/buy/item.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            id: item_id,
            gid: gid
        }
    });
}

// 打开当前用户自己的个人页面
function openWin_MyPage(e) {
    if (e) {
        e.preventDefault();
        e.stopPropagation();
    }
    api_openWin({
        name: 'win_mypage',
        url: 'widget://html/user/user_center.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            from: 1
        }
    });
}

// 打开用户的个人页面
function openWin_UserPage(uid) {
    //console.log('openWin_UserPage uid=' + uid)
    if (uid == 0) {
        return;
    }
    var id = '';
    var login = $api.getStorage('login');
    if (login && login.key) {
        id = $api.getStorage('userinfo').data.id;
    }
    if (id == uid) {
        openWin_MyPage();
    } else {
        api_openWin({
            name: 'win_others_page',
            url: 'widget://html/user/others_page.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            reload: true,
            pageParam: {
                uid: uid
            }
        });
    }
}

// 打开地图
function openWin_Map(position, lat, lon) {
    api.openWin({
        name: 'win_map',
        url: 'widget://html/top/map.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            position: position,
            lat: lat,
            lon: lon
        },
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开图片浏览器
function openWin_ImageView(obj) {
    var $this = $(obj);
    var $img = $this.find('img').eq(0);
    var $parent = $this.parent().parent();
    var $imgs = $parent.find('img');
    var index = $imgs.index($img);
    var imgs = [];

    $imgs.each(function() {
        var src = $(this).data('src');
        var id = $(this).data('id');
        imgs.push({
            src: src,
            id: id
        });
    })
    openImageBrower(imgs, index)
}

function openImageBrower(imgs, index) {
    api.openWin({
        name: 'win_image',
        url: 'widget://html/image_browser.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            imgs: imgs,
            index: index
        },
        animation: {
            type: 'none',
            subType: 'from_right',
            duration: 0
        }
    });
}

// 打开话题
function openWin_posts(topic_id, topic_name, close_winname) {
    api_openWin({
        name: 'win_topic' + topic_id,
        url: 'widget://html/topic/post_list.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            winname: 'root',
            cid: topic_id,
            name: topic_name,
            close_winname: close_winname
        }
    });
}

// 打开发布话题 发帖页面
function openWin_ReportTalk(id, name, from) {
    var cid = '';
    var cname = '';
    if (id) {
        cid = id;
        cname = name;
    }
    api.openWin({
        name: 'win_add_post',
        url: 'widget://html/topic/add_post.html',
        bounces: false,
        reload: true,
        allowEdit: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            cid: cid,
            cname: cname,
            from: from,
            winname: api.winName
        }
    });
}

// 打开发布急问页
function openWin_ReportQuestion(type, id, name) {
    var cid = '';
    var cname = '';
    var ctype = 'root';
    if (type) {
        ctype = type;
    }
    if (id) {
        cid = id;
        cname = name;
    }
    api.openWin({
        name: 'win_report_question',
        url: 'widget://html/report/question.html',
        bounces: false,
        reload: true,
        allowEdit: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            cid: cid,
            cname: cname,
            type: ctype
        },
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开发布渔汛页
function openWin_ReportFishMsg(p) {
    var place = p ? p : '';
    api.openWin({
        name: 'win_report_fishmsg',
        url: 'widget://html/report/fishmsg.html',
        bounces: false,
        reload: true,
        allowEdit: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            place: place
        },
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开发布约钓页
function openWin_ReportTravel() {
    api.openWin({
        name: 'win_report_travel',
        url: 'widget://html/report/travel.html',
        bounces: false,
        reload: true,
        allowEdit: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        softInputMode: 'pan',
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开规则页
function openWin_Rule() {
    api.openWin({
        name: 'win_rule',
        url: 'widget://html/system/rule.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true
    });
}

// 打开客服页
function openWin_Service(id, name) {
    if (checkLogin('win_url')) {
        openWin_Chat(id, name);
    }
}
// 打开官方咪凹
function openWin_SysChat(id, name) {
    if (checkLogin('root')) {
        openWin_Chat('1-' + getLoginUserInfo().id, '官方咪凹');
    }
}

// 打开聊天页 id 对方uid，name对方昵称
function openWin_Chat(id, name) {
    id = id + ''
    if(id.indexOf('-') < 0) {
      var userinfo = getLoginUserInfo()
      console.log('userinfo=' + JSON.stringify(userinfo))
      var mid = userinfo.id
      if(mid==null) mid = userinfo.uid
      if(id == mid) return;
      if(id > mid) id = mid + '-' +id
      else id = id + '-' + mid
    }
    log('talk_key=' + id + ' name=' + name)
    api_openWin({
        name: 'win_chat',
        url: 'widget://html/message/chat.html',
        bounces: true,
        reload: true,
        allowEdit: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            id: id,
            name: name
        }
    });
}

// 打开群聊天页
function openWin_ChatGroup(id, name) {
    api_openWin({
        name: 'win_chat_group',
        url: 'widget://html/message/chat_group.html',
        bounces: true,
        reload: true,
        allowEdit: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            id: id,
            name: name
        }
    });
}

// 打开订单详情页
function openWin_Order(orderID, tradeNO, type) {
    var winname = '';
    if (type) {
        winname = type;
    }
    api.openWin({
        name: 'win_order_detail',
        url: 'widget://html/userspace/order_detail.html',
        bounces: false,
        vScrollBarEnabled: true,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            orderID: orderID,
            tradeNO: tradeNO,
            winname: winname
        }
    });
}

function openWin_ProductDetail(tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/product_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            id: theme_id,
            extra: extra,
            from: from
        }
    });
}

function openWin_DealerDetail(tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/dealer_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: 0,
            id: theme_id,
            extra: extra,
            from: from
        }
    });
}

function openWin_EnterpriseDetail(tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    log('openWin_EnterpriseDetail id=' + theme_id);
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/enterprise_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            id: theme_id,
            extra: extra,
            from: from
        }
    });
}

function openWin_ActivityDetail(cid, tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/activity_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: cid,
            tid: theme_id,
            extra: extra,
            from: from
        }
    });
}

function openWin_BidDetail(cid, tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/bid_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: cid,
            tid: theme_id,
            extra: extra,
            from: from
        }
    });
}

function openWin_MarketingDetail(cid, tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    api_openWin({
        name: 'win_talk_' + theme_id,
        url: 'widget://html/topic/marketing_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: cid,
            tid: theme_id,
            extra: extra,
            from: from
        }
    });
}

function openWin_RequireDetail(tid, ex, event, from) {
    if (event) {
        event.preventDefault();
        event.stopPropagation();
    }
    var theme_id = tid ? tid : 0;
    var extra = ex ? ex : '';
    log('openWin_RequireDetail id=' + theme_id)
    api_openWin({
        name: 'win_require_' + theme_id,
        url: 'widget://html/topic/require_detail.html',
        bounces: false,
        allowEdit: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        reload: true,
        pageParam: {
            cid: 0,
            tid: theme_id,
            extra: extra,
            from: from
        }
    });
}

// 打开约钓筛选页
function openWin_FilterTravel() {
    api.openWin({
        name: 'win_travel_filter',
        url: 'widget://html/travel/filter_travel.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        allowEdit: false,
        slidBackEnabled: true,
        softInputMode: 'pan',
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开钓场搜索页
function openWin_SearchPlace(type, win, frame, script) {
    var winname = win ? win : '';
    var framename = frame ? frame : '';
    var scriptname = script ? script : '';
    api.openWin({
        name: 'win_place_search',
        url: 'widget://html/top/search_place.html',
        bounces: false,
        vScrollBarEnabled: true,
        hScrollBarEnabled: false,
        allowEdit: true,
        slidBackEnabled: true,
        pageParam: {
            type: type,
            winname: winname,
            framename: framename,
            scriptname: scriptname
        },
        softInputMode: 'pan',
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开钓场搜索结果页
function openWin_SearchPlaceList(keyword, type, winname, framename, scriptname) {
    api_openWin({
        name: 'win_search_place',
        url: 'widget://html/search/place.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            keyword: keyword,
            type: type,
            winname: winname,
            framename: framename,
            scriptname: scriptname
        }
    });
}

// 打开急问搜索页
function openWin_SearchQuestion() {
    api.openWin({
        name: 'win_question_search',
        url: 'widget://html/question/search.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        allowEdit: true,
        slidBackEnabled: true,
        softInputMode: 'pan',
        animation: {
            type: 'fade',
            subType: 'from_right',
            duration: 300
        }
    });
}

// 打开急问搜索结果页
function openWin_SearchQuestionList(keyword) {
    api_openWin({
        name: 'win_search_question',
        url: 'widget://html/search/question.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            keyword: keyword
        }
    });
}

// 打开钓友搜索结果页
function openWin_SearchUserList(keyword) {
    api_openWin({
        name: 'search_list_users',
        url: 'widget://html/topic/search_list_users.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            keyword: keyword
        }
    });
}

// 打开窝子搜索页
function openWin_SearchClub(opt) {
    api_openWin_fade({
        name: 'win_club_search',
        url: 'widget://html/club/search.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        allowEdit: true,
        slidBackEnabled: true,
        pageParam: opt,
        softInputMode: 'pan'
    });
}

// 打开窝子搜索结果页
function openWin_SearchClubList(opt) {
    api_openWin({
        name: 'win_search_club',
        url: 'widget://html/search/club.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: opt
    });
}

function openWin_MyTopics() {
    if (checkLogin('root')) {
        api_openWin({
            name: 'my_create_topics',
            url: 'widget://html/topic/my_create_topics.html',
            bounces: false,
            vScrollBarEnabled: true,
            hScrollBarEnabled: false,
            slidBackEnabled: true
        });
    }
}

function openBanner(banner) {
    if (banner.topic_id) {
        // var topic_name = url.substring(url.indexOf('topic://') + 1)
        openWin_Club(banner.topic_id, banner.topic_name)
        return
    }
    if (banner.post_id) {
        openWin_Talk(0, banner.post_id)
        return
    }
    openUrl(banner.link_url, banner.title);
}

function openMediaUrl(url, title) {
    openUrl(url, title, null, 1)
}

// 打开链接 type 1 video url
function openUrl(url, title, anitype, type) {
    if (!url || url.indexOf('http') != 0) {
        // showResult('地址不存在')
        return
    }
    var url = url.replace(/&amp;/g, '&');
    var str = '';
    var animation = 'movein';
    if (title) {
        str = title;
    }
    if (anitype) {
        animation = anitype;
    }
    if (url.indexOf(window.config.root_path + '/circle/index.php?act=theme&op=theme_detail') == 0 || url.indexOf(window.config.root_path_old + '/circle/index.php?act=theme&op=theme_detail') == 0) {
        var opt = url.substr(url.indexOf('?') + 1).split('&');
        var cid = '0';
        var tid = '0';
        for (var i = 0; i < opt.length; i++) {
            var param = opt[i];
            if (/c_id=/.test(param)) {
                cid = param.replace('c_id=', '');
            } else if (/t_id=/.test(param)) {
                tid = param.replace('t_id=', '');
            }
        }
        if (cid !== '0' && tid !== '0') {
            openWin_Talk(cid, tid);
        }
    } else if (url.indexOf(window.config.source_path + '/index.php?act=travel&op=detail') == 0 || url.indexOf(window.config.source_path_old + '/index.php?act=travel&op=detail') == 0) {
        var opt = url.substr(url.indexOf('?') + 1).split('&');
        var travel_id = '0';
        for (var i = 0; i < opt.length; i++) {
            var param = opt[i];
            if (/travel_id=/.test(param)) {
                travel_id = param.replace('travel_id=', '');
            }
        }
        if (travel_id !== '0') {
            openWin_Travel(travel_id);
        }
    } else if (url.indexOf(window.config.root_path + '/shop/index.php?act=member_order&op=show_order') == 0 || url.indexOf(window.config.root_path_old + '/shop/index.php?act=member_order&op=show_order') == 0) {
        url = window.config.root_path + '/wap/app_jump.html?key=' + $api.getStorage('login').key + '&name=' + $api.getStorage('login').username + '&reurl=' + encodeURI(window.config.root_path + '/wap/tmpl/member/order_list.html');
        api_openWin({
            name: 'win_url',
            url: 'widget://html/browser.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            reload: true,
            pageParam: {
                url: url,
                title: str,
                anitype: animation,
                type: type
            }
        });
    } else if (url.indexOf(window.config.root_path + '/wap/special.html') == 0 || url.indexOf(window.config.root_path_old + '/wap/special.html') == 0) {
        url = window.config.root_path + '/wap/app_jump.html?reurl=' + encodeURI(url);
        if ($api.getStorage('login') && $api.getStorage('login').key) {
            url = url + '&key=' + $api.getStorage('login').key + '&name=' + $api.getStorage('login').username;
        }
        api_openWin({
            name: 'win_url',
            url: 'widget://html/browser.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: false,
            reload: true,
            pageParam: {
                url: url,
                title: str,
                anitype: animation
            }
        });
    } else if (url.indexOf(window.config.root_path + '/wap/tmpl/product_list.html') == 0 || url.indexOf(window.config.root_path_old + '/wap/tmpl/product_list.html') == 0) {
        url = window.config.root_path + '/wap/app_jump.html?reurl=' + encodeURI(url);
        if ($api.getStorage('login') && $api.getStorage('login').key) {
            url = url + '&key=' + $api.getStorage('login').key + '&name=' + $api.getStorage('login').username;
        }
        api_openWin({
            name: 'win_url',
            url: 'widget://html/browser.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: false,
            reload: true,
            pageParam: {
                url: url,
                title: str,
                anitype: animation
            }
        });
    } else if (url.indexOf(window.config.root_path + '/wap/tmpl/product_detail.html') == 0 || url.indexOf(window.config.root_path_old + '/wap/tmpl/product_detail.html') == 0) {
        url = window.config.root_path + '/wap/app_jump.html?reurl=' + encodeURI(url);
        if ($api.getStorage('login') && $api.getStorage('login').key) {
            url = url + '&key=' + $api.getStorage('login').key + '&name=' + $api.getStorage('login').username;
        }
        api_openWin({
            name: 'win_url',
            url: 'widget://html/browser.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: false,
            reload: true,
            pageParam: {
                url: url,
                title: str,
                anitype: animation
            }
        });
    } else if (url.indexOf('yefudy://') == 0) {
        url = url.replace('yefudy://', '');
        var type = url.substr(0, url.indexOf('?'));
        var opt = url.substr(url.indexOf('?') + 1).split('&');
        if (type === 'theme') {
            var cid = '0';
            var tid = '0';
            for (var i = 0; i < opt.length; i++) {
                var param = opt[i];
                if (/c_id=/.test(param)) {
                    cid = param.replace('c_id=', '');
                } else if (/t_id=/.test(param)) {
                    tid = param.replace('t_id=', '');
                }
            }
            if (cid !== '0' && tid !== '0') {
                openWin_Talk(cid, tid);
            }
        } else if (type === 'shop' && checkLogin('root')) {
            openUrl(window.config.source_path + '/index.php?act=score_shop&op=index&key=' + $api.getStorage('login').key, '积分商城');
        }
    } else {
        api_openWin({
            name: 'win_url',
            url: 'widget://html/browser.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            reload: true,
            pageParam: {
                url: url,
                title: str,
                anitype: animation,
                type: type
            }
        });
    }
}

// 显示天气页
function showWeather(status) {
    var first = status ? status : false;
    api.openWin({
        name: 'weather',
        url: 'widget://html/weather.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        pageParam: {
            first: first
        },
        animation: {
            type: 'movein',
            subType: 'from_left',
            duration: 300
        }
    });
}

// 任务奖励提示
function showQuest(opt, winname) {
    api.openFrame({
        name: 'quest_layer',
        url: 'widget://html/quest_layer.html',
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        pageParam: {
            rule_name: opt.rule_name,
            rule_title: opt.rule_title,
            points: opt.points,
            winname: winname
        },
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        }
    });
}

// 操作结果提示
function showResult(str, callback) {
    if (is_browser) {
        var dialog = "<div class='message'><span class='message_box'>" + str + "</span></div>";
        $($("body")[0]).append(dialog);
        var width = ($('.message')[0].clientWidth - $('.message_box')[0].clientWidth) / 2

        setTimeout(function() {
            var message = $('.message')[0]
            message.parentNode.removeChild(message)
        }, 1500);
        if (callback) {
            setTimeout(callback, 1500)
        }
        setTimeout(function() {
            $('.message').fadeOut(300)
        }, 700)
        return
    }
    var win_width = api.winWidth;
    var win_height = api.winHeight;
    var layer_width = Math.round(win_width * 0.54);
    api.closeFrame({
        name: 'att_layer'
    });
    api.openFrame({
        name: 'att_layer',
        url: 'widget://html/attention_layer.html',
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        pageParam: {
            str: str,
            type: 'success'
        },
        rect: {
            x: Math.round((win_width - layer_width) / 2),
            y: Math.round((win_height - 100) / 2),
            w: layer_width,
            h: 100
        }
    });
    if (callback) {
        setTimeout(callback, 1500)
    }
}

function blurAllInput() {
    $('textarea').blur()
    $('input').blur()
}

// 加载提示，提交表单提示
function showLoading(config) {
    var layer = {
        x: 0,
        y: 0,
        w: 'auto',
        h: 'auto'
    };
    if (config) {
        layer = $.extend(layer, config);
    }
    api.openFrame({
        name: 'loading_layer',
        url: 'widget://html/loading_layer.html',
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        rect: layer
    });
}

// 关闭加载提示
function hideLoading() {
    api.closeFrame({
        name: 'loading_layer'
    });
}

var dataLoadingId = 0
var uiloading = null

// 数据加载提示，显示在页面中间
function showDataLoading(config) {
    if (uiloading == null) uiloading = api.require('UILoading');
    if (uiloading == null) return;
    uiloading.keyFrame({
        rect: {
            w: 100,
            h: 100
        },
        styles: {
            bg: 'rgba(0,0,0,0.5)',
            corner: 5,
            interval: 50,
            frame: {
                w: 80,
                h: 80
            }
        }
    }, function(ret) {
        alert(JSON.stringify(ret));
    });
}

function hideDataLoading() {
    if (uiloading == null) return
    uiloading.closeKeyFrame();
}

function ui_refreshApp() {
    api.execScript({
        name: 'root',
        script: 'refreshAPP()'
    });
}

function openWin_TopicShare(cid, tid, winname, framename) {
    api.openFrame({
        name: 'topic_share',
        url: 'widget://html/topic/share.html',
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        pageParam: {
            cid: cid,
            tid: tid,
            winname: winname,
            framename: framename
        },
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        }
    });
}

var build_time = function(time) {
    if (time == '') return;
    var now = new Date().getTime();
    time = Math.round(now / 1000) - time;
    if (time <= 0) return '刚刚';
    var times = '';
    var years = Math.floor(time / 31104000);
    var months = Math.floor((time / 2592000) % 12);
    var days = Math.floor((time / 86400) % 30);
    var hours = Math.floor((time / 3600) % 24);
    var minutes = Math.floor((time / 60) % 60);
    time = Math.floor(time % 60);
    if (time >= 1) times = time + '秒';
    if (minutes >= 1) times = minutes + '分钟';
    if (hours >= 1) times = hours + '小时';
    if (days >= 1) times = days + '天';
    if (months >= 1) times = months + '月';
    if (years >= 1) times = years + '年';
    times += '前';
    return times;
}
var build_content = function(str) {
    if (str == '') {
        return;
    } else {
        var s = utf16_to_ucs2(str.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
        if (s.length > 50) {
            s = substrsp(s, 0, 50) + '…';
        }
        return s.replace(/\r\n|\n/g, '<br>');
    }
}
var build_post_content = function(str) {
    if (str == '' || !str) {
        return;
    } else {
        var s = utf16_to_ucs2(str.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
        //if (s.length > 50) {
        //    s = substrsp(s, 0, 50) + '…';
        //}
        s = s.replace(/\r\n|\n/g, '<br>');
        return convertEmoji(s, '../../image/');
    }
}
var build_reply_content = function(str) {
    if (str == '') {
        return;
    } else {
        str = utf16_to_ucs2(str.replace(/\[链接\]\S+\[\/链接\]/g, function(val) {
            var url = val.substr(4, val.length - 9);
            return "<span class='app-link' tapmode='' onclick='openUrl(&quot;" + url + "&quot;)'></span>";
        }).replace(/\r\n|\n/g, "<br>"));

        return convertEmoji(utf16_to_ucs2(str), '../../image/');
    }
}

function request_followUser(uid, cbk) {
    // var is_follow = vm.topic.author.is_follow
    ajaxGet(config.urls.follow, {
        his_uid: uid
    }, function(ret, err) {
        // var msg = ''
        if (!err) {
            showResult(ret.info)
        }
        if (cbk) cbk(ret)
    })
}

function lazy_load_data_on_page(func) {
    setTimeout(func, 400)
}

function checkUpdate() {
    if (api.systemType == 'ios') return
    var mam = api.require('mam');
    mam.checkUpdate(function(ret, err) {
        if (ret) {
            var result = ret.result;
            if (result.update == true && result.closed == false) {
                // + ';下载地址:' + result.source
                var str = '新版本型号:' + result.version + ';\n更新提示:' + result.updateTip + ';\n发布时间:' + result.time;
                api.confirm({
                    title: '有新的版本,是否下载并安装 ',
                    msg: str,
                    buttons: ['确定', '取消']
                }, function(ret, err) {
                    if (ret.buttonIndex == 1) {
                        if (api.systemType == "android") {
                            api.download({
                                url: result.source,
                                report: true
                            }, function(ret, err) {
                                if (ret && 0 == ret.state) { /* 下载进度 */
                                    api.toast({
                                        msg: "正在下载应用" + ret.percent + "%",
                                        duration: 2000
                                    });
                                }
                                if (ret && 1 == ret.state) { /* 下载完成 */
                                    var savePath = ret.savePath;
                                    api.installApp({
                                        appUri: savePath
                                    });
                                }
                            });
                        }
                        if (api.systemType == "ios") {
                            api.installApp({
                                appUri: result.source
                            });
                        }
                    }
                });
            } else {
                api.alert({
                    msg: "暂无更新"
                });
            }
        } else {
            api.alert({
                msg: err.msg
            });
        }
    });
}

function initImgUpload($imgupload, max, callback) {
    var imgid = 0;
    var addbtn = $('.btn-add', $imgupload)
        // console.log('add btn click...' + addbtn)
    addbtn.click(function() {
        api.actionSheet({
            buttons: ['拍照', '从手机相册选择']
        }, function(ret, err) {
            var index = ret.buttonIndex;
            if (index === 1) {
                openCameraForUpload();
            } else if (index === 2) {
                openAlbumForUpload();
            }
        });
    })

    // 选择图片（相机）
    function openCameraForUpload() {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'url',
            allowEdit: false,
            quality: 100,
            saveToPhotoAlbum: false
        }, function(ret, err) {
            if (ret) {
                var data = ret.data;
                if (data === '') {
                    return;
                }
                uploadPhoto(data);
            }
        });
    }

    // 选择图片（相册）
    function openAlbumForUpload() {
        var mediaScanner = api.require('UIMediaScanner');
        mediaScanner.open({
            exchange: true,
            column: 4,
            classify: false,
            max: max,
            sort: {
                key: 'time',
                order: 'desc'
            },
            texts: {
                stateText: '已选择*项',
                cancelText: '取消',
                finishText: '完成'
            },
            styles: {
                bg: '#ffe14d',
                mark: {
                    icon: '',
                    position: 'bottom_left',
                    size: 20
                },
                nav: {
                    bg: '#eee',
                    stateColor: '#000',
                    stateSize: 18,
                    cancelBg: 'rgba(0,0,0,0)',
                    cancelColor: '#000',
                    cancelSize: 18,
                    finishBg: 'rgba(0,0,0,0)',
                    finishColor: '#000',
                    finishSize: 18
                }
            }
        }, function(ret) {
            if (ret && ret.list.length > 0) {
                var length = ret.list.length;
                for (var i = 0; i < length; i++) {
                    mediaScanner.transPath({
                        path: ret.list[i].path
                    }, function(ret) {
                        uploadPhoto(ret.path);
                    });
                }
            }
        });
    }

    $($imgupload).on('click', '.btn-del', function() {
        console.log('click del btn')
        $(this).parents('.photo-item').remove()
        max += 1
        if (max == 1) {
            $('.btn-add', $imgupload).css('display', 'block');
        }
    })

    $($imgupload).on('load', '.up-pic', function() {
        showImg(this)
    })
    $($imgupload).on('click', '.up-pic', function() {
        openImg(this)
    })

    function showImg(obj) {
        var $this = $(obj);
        $this.removeClass('hidden').addClass('fadein');
    }

    function openImg(obj) {
        var $this = $(obj);
        // $this.removeClass('hidden').addClass('fadein');
        var url = $this.attr('src')
        var imgs = [];
        $('.up-pic').each(function() {
            var src = $(this).attr('src');
            var id = $(this).data('id');
            if (id) imgs.push({
                src: src,
                id: id
            });
        })
        var index = $('.up-pic').index($this);
        openImageBrower(imgs, index)
    }

    function uploadPhoto(src) {
        console.log('select img src=' + src)
        imgid = imgid + 1;
        var imgid_temp = imgid;
        max = max - 1;
        if (max < 2) {
            $($imgupload).addClass('more');
            if (max < 1) {
                $('.btn-add', $imgupload).css('display', 'none');
            }
        }
        // uploading = uploading + 1;
        var $node = $('<div class="photo-item loading item-' + imgid_temp + '"><div class="dummy"></div><span class="uploading1"></span><i tapmode="" class="btn-del" data-id="' + imgid_temp + '"></i></div>');
        $('.upload-photo-temp', $imgupload).css('display', 'block');
        $('.btn-add', $imgupload).before($node);

        console.log('max=' + max + ' imgid=' + imgid)
        compressImg({
            src: src,
            id: imgid
        }, function(filepath, fileid) {
            console.log('filepath=' + filepath + ' fileid=' + fileid)
            $node.removeClass('loading').prepend(
                '<img class="hidden up-pic" src="' + filepath + '"' +
                ' data-id="' + fileid + '"' +
                // ' onload="showImg(this)" ' +
                'alt="" >');
            $node.find('i').data('id', fileid);
            console.log($node.html())
            api.parseTapmode();
        }, function(err) {
            console.log(err)
        })
    }
}

function openDealAreaSelectWin(selectIds, isMultiSelect) {
    api.openWin({
        name: 'win_edit_position',
        url: 'widget://html/product/edit_position.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            type: 'add',
            winname: api.winName,
            framename: api.frameName,
            selectIds: selectIds,
            multiSelect: isMultiSelect
        },
        animation: {
            type: 'movein',
            subType: 'from_right',
            duration: 300
        }
    });
}

function openChannelSelectWin(selectIds, isMultiSelect) {
    api.openWin({
        name: 'win_edit_channel',
        url: 'widget://html/product/edit_channel.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            type: 'add',
            winname: api.winName,
            framename: api.frameName,
            selectIds: selectIds,
            multiSelect: isMultiSelect
        },
        animation: {
            type: 'movein',
            subType: 'from_right',
            duration: 300
        }
    });
}

function openDeptSelectWin(selectIds, isMultiSelect) {
    api.openWin({
        name: 'win_edit_dept',
        url: 'widget://html/product/edit_dept.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            type: 'add',
            winname: api.winName,
            framename: api.frameName,
            selectIds: selectIds,
            multiSelect: isMultiSelect
        },
        animation: {
            type: 'movein',
            subType: 'from_right',
            duration: 300
        }
    });
}

function openCategorySelectWin(selectIds, isMultiSelect) {
    api.openWin({
        name: 'win_edit_category',
        url: 'widget://html/product/edit_category.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            type: 'add',
            winname: api.winName,
            framename: api.frameName,
            selectIds: selectIds,
            multiSelect: isMultiSelect
        },
        animation: {
            type: 'movein',
            subType: 'from_right',
            duration: 300
        }
    });
}

function openRequireCategorySelectWin(selectIds, isMultiSelect) {
    api.openWin({
        name: 'win_edit_require_category',
        url: 'widget://html/product/edit_require_category.html',
        bounces: false,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: true,
        pageParam: {
            type: 'add',
            winname: api.winName,
            framename: api.frameName,
            selectIds: selectIds,
            multiSelect: isMultiSelect
        },
        animation: {
            type: 'movein',
            subType: 'from_right',
            duration: 300
        }
    });
}

function getSelectListConf(cbk) {
    var conf = $api.getStorage('select_list_conf');
    if (conf == null) return {}
    if (conf.dept_list) {
        conf.dept_list.insert(0, {
            id: 0,
            name: '全部科室'
        })
    }
    if (conf.category_list) {
        conf.category_list.insert(0, {
            id: 0,
            name: '产品类别'
        })
    }
    if (conf.channel_list) {
        conf.channel_list.insert(0, {
            id: 0,
            name: '全部渠道'
        })
    }
    return conf
}

function searchHistory_add(key) {
    var list = searchHistory_get()
    if (list == null) list = []
    if (list.indexOf(key) >= 0) return
    list.push(key)
    $api.setStorage('search_history', list);
    return list
}

function searchHistory_get() {
    return $api.getStorage('search_history');
}

function searchHistory_clear() {
    $api.rmStorage('search_history');
}

// 更新用户信息
function updateUserInfo() {
	//var userkey = vm.user.token

	getUserInfo(null, function(userinfo) {
			hideLoading();
			// $api.setStorage('login', {
			// 		key: userkey,
			// 		username: username
			// });
			ui_refreshApp()
			api.execScript({
					name: 'root',
					frameName: 'userspace',
					script: 'updateUserInfo()'
			});
			//if (!noclose) closeThis();
	}, function() {
			hideLoading();
			//if (!noclose) closeThis();
	});
}

// 打开用户协议页
function openUserAgreement() {
    openUrl(config.urls.article + '?alias=protocol', '星医百协议')
}

function open_dial(title, tel1, tel2) {
  if(tel2 && tel2 != '') {
    api.actionSheet({
        title: title,
        buttons: [tel1, tel2]
    }, function (ret, err) {
        var index = ret.buttonIndex;
        if (index === 1) {
            api_openDial(tel1)
        } else if (index === 2) {
            api_openDial(tel2)
        }
    });
  } else {
    api_openDial(tel1)
  }
}
