var source_path = window.config.source_path;
var isTouch = false;
var menu_show = false;
var del_id;
var del_type;
var rongcloud;
var list_tpl;

// 打开系统消息页
function openWin_Sys() {
    if (checkLogin('root') && click_allowed) {
        api.openWin({
            name: 'win_msg_sys',
            url: 'widget://html/message/system.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            animation: {
                type: 'movein',
                subType: 'from_right',
                duration: 300
            }
        });
    }
}

// 打开新的钓友页
function openWin_Friend() {
    if (checkLogin('root') && click_allowed) {
        api.openWin({
            name: 'win_msg_friend',
            url: 'widget://html/message/friend.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            animation: {
                type: 'movein',
                subType: 'from_right',
                duration: 300
            }
        });
    }
}

// 打开江湖钓场
function openWin_Diaochang() {
    if (checkLogin('root') && click_allowed) {
        api.openWin({
            name: 'win_msg_diaochang',
            url: 'widget://html/message/diaochang.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            animation: {
                type: 'movein',
                subType: 'from_right',
                duration: 300
            }
        });
    }
}

// 打开点赞页
function openWin_Like() {
    if (checkLogin('root') && click_allowed) {
        api.openWin({
            name: 'win_msg_like',
            url: 'widget://html/message/like_main.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            animation: {
                type: 'movein',
                subType: 'from_right',
                duration: 300
            }
        });
    }
}

function openWin_Comments() {
    if (checkLogin('root') && click_allowed) {
        api.openWin({
            name: 'win_msg_comments',
            url: 'widget://html/message/comments.html',
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: true,
            animation: {
                type: 'movein',
                subType: 'from_right',
                duration: 300
            }
        });
    }
}

// 兼容老版本的打开聊天页
function chat(id, obj) {
    openChat(id, obj);
}

// 打开聊天页
function openChat(id, obj) {
    if (click_allowed && !menu_show) {
        var $this = $(obj);
        var $name = $this.find('.title');
        //rongcloud.clearMessagesUnreadStatus({
        //    conversationType: 'PRIVATE',
        //    targetId: id
        //}, function (ret, err) {
        //    if (ret.status) {
        //        $this.removeClass('new-0');
        //        $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
        //        api.execScript({
        //            name: 'root',
        //            script: 'refreshMsgNumber()'
        //        });
        //    }
        //})
        var name = $name.text();
        openWin_Chat(id, name);
    }
}

// 打开群聊天页
function openChatGroup(id, obj) {
    if (click_allowed && !menu_show) {
        var $this = $(obj);
        //if ($this.hasClass('quit')) {
        //	$this.removeClass('new-0');
        //	$api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
        //	var unread_num = $('#chat-box .click-item.new-0').length;
        //	refresh(function(data){
        //		setTag('sys', data.sys);
        //		setTag('like', data.like);
        //		setTag('reply', data.reply);
        //	}, unread_num);
        //	showResult('你已经不是该约钓群的成员');
        //	return;
        //}
        var $name = $this.find('.title');
        //rongcloud.clearMessagesUnreadStatus({
        //    conversationType: 'GROUP',
        //    targetId: id
        //}, function (ret, err) {
        //    if (ret.status) {
        //        $this.removeClass('new-0');
        //        $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
        //        api.execScript({
        //            name: 'root',
        //            script: 'refreshMsgNumber()'
        //        });
        //    }
        //})
        var name = $name.text();
        openWin_ChatGroup(id, name);
    }
}

// 清除聊天未读标记
function clearUnread(tid, type) {
    var $node = $('#chat-' + tid);
    if ($node.length > 0) {
        //rongcloud.clearMessagesUnreadStatus({
        //    conversationType: type,
        //    targetId: tid
        //}, function (ret, err) {
        //    if (ret.status) {
        //        $node.removeClass('new-0');
        //        $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
        //        api.execScript({
        //            name: 'root',
        //            script: 'refreshMsgNumber()'
        //        });
        //    }
        //})
    }
}

// 清空所有消息
function clearMsg() {
    $('#chat-box').html('');
    setTag('sys', {
        countnum: 0,
        last_message: '嗨，欢迎来到咪凹！'
    });
    setTag('fishmsg', {
        countnum: 0,
        last_message: '订阅、管理钓场，掌握第一手渔汛！'
    });
    setTag('like', {
        countnum: 0,
        last_message: '发表话题可以收获钓友的赞哦'
    });
    setTag('reply', {
        countnum: 0,
        last_message: '发帖、回帖，和钓友互动收获快乐'
    });
}

// 更新聊天未读消息
function updateMsg_chat(ret) {
    var list = ret.result;
    var length = list.length;
    var length_chat = $('#chat-box .click-item').length;
    if (length_chat == 0) {
        var tips = juicer(list_tpl, {list: list});
        $('#chat-box').html(tips);
        api.parseTapmode();
        for (var i = 0; i < length; i++) {
            if (list[i].conversationType == 'GROUP') {
                var tid = list[i].targetId.replace('travel_', '');
                getTravelMain(tid, function (name, id) {
                    $('#name-travel_' + id).text(name).addClass('done');
                    $('#tag-travel_' + id).removeClass('show').addClass('show');
                })
            } else {
                var mid = list[i].targetId;
                getOtherUserInfo(mid, function (data, id) {
                    avatar = data.member_avatar;
                    name = data.member_name;
                    if (avatar != null && avatar != '') {
                        $('#avatar-' + id).attr('src', avatar);
                    }
                    $('#name-' + id).text(name).addClass('done');
                    $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
                    setTimeout(function () {
                        $('#tag-' + id).removeClass('show').addClass('show');
                    }, 500)
                })
            }
        }
    } else {
        for (var i = 0; i < length; i++) {
            if (list[i].sentStatus == 'SENT') {
                var mid = list[i].targetId;
                var $item = $("#chat-" + mid);
                if ($item.length > 0) {
                    var time = list[i].sentTime;
                    if (list[i].senderUserId != $api.getStorage('userinfo').data.member_id && list[i].receivedStatus == 'UNREAD' && time != $item.find('.date').data('value')) {
                        $item.addClass('new-0');
                    } else if (list[i].senderUserId != $api.getStorage('userinfo').data.member_id && list[i].unreadMessageCount > 0) {
                        $item.addClass('new-0');
                    }
                    var index = $('#chat-box .click-item').index($item);
                    var msg = build_content(list[i]);
                    if (msg != $item.find('.info').data('value') || time != $item.find('.date').data('value')) {
                        $item.find('.info').attr('data-value', msg).html(build_content_short(list[i]));
                        $item.find('.date').attr('data-value', time).html(build_time(time));
                        for (var j = 0; j < index; j++) {
                            var $item_temp = $('#chat-box .click-item').eq(j);
                            if (time > parseInt($item_temp.find('.date').data('value'))) {
                                $item.insertBefore($item_temp);
                                api.parseTapmode();
                            }
                        }
                    }
                } else {
                    var islast = true;
                    for (var j = 0; j < length_chat; j++) {
                        var $item_temp = $('#chat-box .click-item').eq(j);
                        if (list[i].sentTime > parseInt($item_temp.find('.date').data('value'))) {
                            $(juicer(list_tpl, {list: [list[i]]})).insertBefore($item_temp);
                            api.parseTapmode();
                            islast = false;
                            break;
                        }
                    }
                    if (islast) {
                        $('#chat-box').append(juicer(list_tpl, {list: [list[i]]}));
                        api.parseTapmode();
                    }
                }
            }
        }
        $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
        var length_new = $('#chat-box .click-item').length;
        for (j = 0; j < length_new; j++) {
            var $item_temp = $('#chat-box .click-item').eq(j);
            if ($item_temp.hasClass('group')) {
                var tid = $item_temp.data('id').replace('travel_', '');
                getTravelMain(tid, function (name, id) {
                    if (name != $('#name-travel_' + id).text()) {
                        $('#name-travel_' + id).text(name).addClass('done');
                    }
                    $('#tag-travel_' + id).removeClass('show').addClass('show');
                    $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
                })
            } else {
                var mid = $item_temp.data('id');
                getOtherUserInfo(mid, function (data, id) {
                    avatar = data.member_avatar;
                    name = data.member_name;
                    if (avatar != null && avatar != '' && avatar != $('#avatar-' + id).attr('src')) {
                        $('#avatar-' + id).attr('src', avatar);
                        setTimeout(function () {
                            $('#tag-' + id).removeClass('show').addClass('show');
                        }, 500)
                    }
                    if (name != $('#name-' + id).text()) {
                        $('#name-' + id).text(name).addClass('done');
                    }
                    $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
                })
            }
        }
    }
}

// 更新APP未读消息
function updateMsg_app(opt) {
    if (opt) {
        setTag('sys', opt.sys);
        setTag('like', opt.like);
        setTag('reply', opt.reply);
        setTag('fishmsg', opt.fishmsg);
        $api.setStorage('msg_list_' + $api.getStorage('userinfo').data.member_id, opt);
    }
}

// 读取APP消息缓存
function loadLocalMsg() {
    var msg_list = $api.getStorage('msg_list_' + $api.getStorage('userinfo').data.member_id);
    if (msg_list != null && msg_list) {
        var msg_sys = msg_list.sys.hasOwnProperty('last_message') ? msg_list.sys.last_message : '';
        var msg_like = msg_list.like.hasOwnProperty('last_message') ? msg_list.like.last_message : '';
        var msg_reply = msg_list.reply.hasOwnProperty('last_message') ? msg_list.reply.last_message : '';
        var msg_fishmsg = msg_list.fishmsg.hasOwnProperty('last_message') ? msg_list.fishmsg.last_message : '';
        if (msg_sys) {
            msg_sys = utf16_to_ucs2(msg_sys.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
            if (msg_sys.length > 50) {
                msg_sys = substrsp(msg_sys, 0, 50) + '…';
            }
            $('#info-sys').text(msg_sys);
        }
        if (msg_like) {
            msg_like = utf16_to_ucs2(msg_like.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
            if (msg_like.length > 50) {
                msg_like = substrsp(msg_like, 0, 50) + '…';
            }
            $('#info-like').text(msg_like);
        }
        if (msg_reply) {
            msg_reply = utf16_to_ucs2(msg_reply.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
            if (msg_reply.length > 50) {
                msg_reply = substrsp(msg_reply, 0, 50) + '…';
            }
            $('#info-reply').text(msg_reply);
        }
        if (msg_fishmsg) {
            msg_fishmsg = utf16_to_ucs2(msg_fishmsg.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
            if (msg_fishmsg.length > 50) {
                msg_fishmsg = substrsp(msg_fishmsg, 0, 50) + '…';
            }
            $('#info-fishmsg').text(msg_fishmsg);
        }
    }
}

// 设定APP未读消息
function setTag(tag, opt) {
    var $tag = $('#' + tag);
    var $tag_num = $('#tag-' + tag);
    var $tag_info = $('#info-' + tag);
    var num = opt.countnum;
    var msg = opt.hasOwnProperty('last_message') ? opt.last_message : '';
    if (num > 99) {
        $tag.removeClass('new new-2').addClass('new-3');
        $tag_num.text('99+');
    } else if (num > 9) {
        $tag.removeClass('new new-3').addClass('new-2');
        $tag_num.text(num);
    } else if (num > 0) {
        $tag.removeClass('new-2 new-3').addClass('new');
        $tag_num.text(num);
    } else {
        $tag.removeClass('new new-2 new-3');
        $tag_num.text(0);
    }
    if (msg) {
        msg = utf16_to_ucs2(msg.replace(/\[链接\]\S+\[\/链接\]|\[图片\S+\]/g, ''));
        if (msg.length > 50) {
            msg = substrsp(msg, 0, 50) + '…';
        }
        $tag_info.text(msg);
    }
}

// 消除APP未读消息标记
function clearAppMsg(tag) {
    setTimeout(function () {
        var $tag = $('#' + tag);
        var $tag_num = $('#tag-' + tag);
        $tag.removeClass('new new-2 new-3');
        $tag_num.text(0);
        var num = parseInt($('#tag-sys').text()) + parseInt($('#tag-like').text()) + parseInt($('#tag-reply').text()) + parseInt($('#tag-fishmsg').text());
        api.execScript({
            name: 'root',
            script: 'updateMsgNumber_app(' + num + ')'
        });
    }, 1500);
}

// juicer自定义函数
var build_time = function (time) {
    if (time == '') return;
    var dt = new Date(time);
    var now = new Date();
    var str = '';
    var hour = dt.getHours();
    if (hour < 10) {
        hour = '0' + hour;
    }
    var min = dt.getMinutes();
    if (min < 10) {
        min = '0' + min;
    }
    if (dt.getFullYear() == now.getFullYear() && dt.getMonth() == now.getMonth() && dt.getDate() == now.getDate()) {
        str = '今天 ' + hour + ':' + min;
    } else {
        str = (dt.getMonth() + 1) + '月' + dt.getDate() + '日 ' + hour + ':' + min;
    }
    return str;
}
var build_content = function (obj) {
    var type = obj.conversationType;
    if (type == 'GROUP') {
        if (obj.senderUserId == 'quit_group_helper') {
            var extra = eval('(' + obj.latestMessage.extra + ')');
            if (extra.MsgType == 'quit_group') {
                if (extra.member_id == $api.getStorage('userinfo').data.member_id && extra.option_memberid == $api.getStorage('userinfo').data.member_id) {
                    return '你已退出该约钓群';
                } else if (extra.member_id == $api.getStorage('userinfo').data.member_id && extra.option_memberid != $api.getStorage('userinfo').data.member_id) {
                    return '你已被创建者移出该约钓群'
                } else {
                    return extra.member_name + '已退出该约钓群';
                }
            } else {
                var str;
                if (obj.objectName == 'RC:ImgMsg') {
                    str = '[图片:' + obj.latestMessageId + ']';
                } else {
                    str = obj.latestMessage.text;
                }
                if (str == '') {
                    return;
                } else {
                    if (obj.senderUserId == $api.getStorage('userinfo').data.member_id) {
                        str = '我：' + str;
                    }
                    return str;
                }
            }
        } else {
            var str;
            if (obj.objectName == 'RC:ImgMsg') {
                str = '[图片:' + obj.latestMessageId + ']';
            } else {
                str = obj.latestMessage.text;
            }
            if (str == '') {
                return;
            } else {
                if (obj.senderUserId == $api.getStorage('userinfo').data.member_id) {
                    str = '我：' + str;
                }
                return str;
            }
        }
    } else {
        var str;
        if (obj.objectName == 'RC:ImgMsg') {
            str = '[图片:' + obj.latestMessageId + ']';
        } else {
            str = obj.latestMessage.text;
        }
        if (str == '') {
            return;
        } else {
            if (obj.senderUserId == $api.getStorage('userinfo').data.member_id) {
                str = '我：' + str;
            }
            return str;
        }
    }
}
var build_content_short = function (obj) {
    var type = obj.conversationType;
    if (type == 'GROUP') {
        if (obj.senderUserId == 'quit_group_helper') {
            var extra = eval('(' + obj.latestMessage.extra + ')');
            if (extra.MsgType == 'quit_group') {
                if (extra.member_id == $api.getStorage('userinfo').data.member_id && extra.option_memberid == $api.getStorage('userinfo').data.member_id) {
                    return '你已退出该约钓群';
                } else if (extra.member_id == $api.getStorage('userinfo').data.member_id && extra.option_memberid != $api.getStorage('userinfo').data.member_id) {
                    return '你已被创建者移出该约钓群'
                } else {
                    return extra.member_name + '已退出该约钓群';
                }
            } else {
                var str;
                if (obj.objectName == 'RC:ImgMsg') {
                    str = '[图片]';
                } else {
                    str = obj.latestMessage.text;
                }
                if (str == '') {
                    return;
                } else {
                    str = str.replace(/\r\n/g, "<br>").replace(/\n/g, "<br>");
                    if (obj.senderUserId == $api.getStorage('userinfo').data.member_id) {
                        str = '我：' + str;
                    }
                    return convertEmoji(utf16_to_ucs2(str), '../../image/');
                }
            }
        } else {
            var str;
            if (obj.objectName == 'RC:ImgMsg') {
                str = '[图片]';
            } else {
                str = obj.latestMessage.text;
            }
            if (str == '') {
                return;
            } else {
                str = str.replace(/\r\n/g, "<br>").replace(/\n/g, "<br>");
                if (obj.senderUserId == $api.getStorage('userinfo').data.member_id) {
                    str = '我：' + str;
                }
                return convertEmoji(utf16_to_ucs2(str), '../../image/');
            }
        }
    } else {
        var str;
        if (obj.objectName == 'RC:ImgMsg') {
            str = '[图片]';
        } else {
            str = obj.latestMessage.text;
        }
        if (str == '') {
            return;
        } else {
            str = str.replace(/\r\n/g, "<br>").replace(/\n/g, "<br>");
            if (obj.senderUserId == $api.getStorage('userinfo').data.member_id) {
                str = '我：' + str;
            }
            return convertEmoji(utf16_to_ucs2(str), '../../image/');
        }
    }
}
var build_status = function (obj) {
    var type = obj.conversationType;
    if (type == 'GROUP') {
        if (obj.latestMessage.extra == '') {
            return '';
        } else {
            var extra = eval('(' + obj.latestMessage.extra + ')');
            if (extra.MsgType == 'quit_group') {
                if (extra.member_id == $api.getStorage('userinfo').data.member_id) {
                    return 'quit';
                } else {
                    return '';
                }
            } else {
                return '';
            }
        }
    } else {
        return '';
    }
}
juicer.register('build_time', build_time);
juicer.register('build_content', build_content);
juicer.register('build_content_short', build_content_short);
juicer.register('build_status', build_status);

apiready = function() { onApiReady();
    list_tpl = $('#list-tpl').html();
    //rongcloud = api.require('rongCloud2');
    var touch_id = 0;
    var $body = $api.dom('body');
    var body_w = $api.offset($body).w;
    var body_h = $api.offset($body).h;

    api.execScript({
        name: 'root',
        script: 'refreshMsgNumber()'
    });
    scroll_click(api.systemType);

    if ($api.getStorage('login') != null && $api.getStorage('login').key) {
        // 首次打开页面时加载暂存的APP消息
        //api.execScript({
        //    name: 'root',
        //    script: 'loadMsgApp()'
        //});
        //loadLocalMsg();

        //var rongcloud_list = $api.getStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id);
        //if (rongcloud_list != null && rongcloud_list) {
        //    $('#chat-box').html(rongcloud_list);
        //    $('#chat-box .click-item').each(function () {
        //        var $this = $(this);
        //        $this.addClass('new-0');
        //        var $date = $this.find('.date');
        //        if ($date.length > 0 && $date.text().indexOf('今天') >= 0) {
        //            $date.text(build_time($date.data('value')));
        //        }
        //    })
        //    api.parseTapmode();
        //}
    }

    $('body').on('touchstart', '#chat-box .click-item', function (e) {
        var $this = $(this);
        if ($this.hasClass('group')) {
            del_type = 'GROUP';
        } else {
            del_type = 'PRIVATE';
        }
        del_id = $this.data('id');
        isTouch = true;
        touch_id = (touch_id + 1) % 1000;
        var touch_id_temp = touch_id;
        setTimeout(function () {
            if (isTouch && touch_id_temp == touch_id) {
                isTouch = false;
                menu_show = true;
                api.actionSheet({
                    buttons: ['删除']
                }, function (ret, err) {
                    menu_show = false;
                    var index = ret.buttonIndex;
                    if (index === 1) {
                        api.confirm({
                            title: '提示',
                            msg: '确定删除该聊天？',
                            buttons: ['取消', '确定']
                        }, function (ret, err) {
                            if (ret.buttonIndex == 2) {
                                //rongcloud.removeConversation({
                                //    conversationType: del_type,
                                //    targetId: del_id.toString()
                                //}, function (ret, err) {
                                //    if (ret.status == 'success') {
                                //        $('#chat-' + del_id).remove();
                                //        $api.setStorage('rongcloud_list_' + $api.getStorage('userinfo').data.member_id, $('#chat-box').html());
                                //        showResult('已删除');
                                //    } else {
                                //        showResult('删除失败<br>请稍后重试');
                                //    }
                                //})
                            }
                        });
                    }
                });
            }
        }, 400)
    }).on('touchmove', '#chat-box .click-item', function () {
        isTouch = false;
    }).on('touchend', '#chat-box .click-item', function (e) {
        isTouch = false;
    })
};
