// 修正JSON数据顺序错乱的问题
function fixJSON(obj) {
    var arr = obj;
    var length = arr.length;
    if (length <= 1) {
        return arr;
    }
    var arr_id = [];
    for (var i = 0; i < length; i++) {
        var id = parseInt(arr[i].messageId);
        var arr_length = arr_id.length;
        if (arr_length == 0) {
            arr_id.push(arr[i]);
        } else {
            for (var j = 0; j < arr_length; j++) {
                var id_temp = parseInt(arr_id[j].messageId);
                if (id < id_temp) {
                    arr_id.insert(j, arr[i]);
                    break;
                } else if (j == arr_length - 1) {
                    arr_id.push(arr[i]);
                }
            }
        }
    }
    return arr_id;
}

var id;
var sys;
var obj_chatbox;
var sending = false;
var loading = false;
var loading_new = false;
var avatar;
var avatar_me;
var avatar_default = window.config.avatar_default;
var timeline_last;
var timeline_temp;
var sendtime;
var sendtime_last = 0;
var rongcloud;
var isFirst = true;
var nomore = false;
var messageid = -1;
var messageid_new = -1;
var copy_content = '';
var isTouch = false;
var menu_show = false;
var source_path = window.config.source_path;
var list_has_more = true;
var list_page_no = 1;
var list_page_size = window.config.list_pagesize;
var list_tpl;
var list_box;
var list_loading;

function closeThis() {
    //api.execScript({
    //    name: 'root',
    //    frameName: 'message',
    //    script: 'clearUnread("' + id + '", "PRIVATE")'
    //});
    api.closeWin({
        name: 'win_chat',
        animation: {
            type: 'reveal',
            subType: 'from_left',
            duration: 300
        }
    });
}

function sendSuccess() {
    obj_chatbox.closeKeyboard();
    obj_chatbox.setPlaceholder({
        placeholder: '内容'
    });
}

function sendFail(str) {
    obj_chatbox.value({
        msg: str
    });
    obj_chatbox.setPlaceholder({
        placeholder: '内容'
    });
}

function showImg(obj) {
    var $parent = $(obj).parent();
    $parent.removeClass('loading');
}

// 发送文本消息
function submit(content) {
    if (sending) {
        return;
    }
    sending = true;
    var str = ucs2_to_utf16(content);
    if (str.length == 0) {
        sending = false;
        showResult('请输入聊天内容');
        return;
    }
    showLoading();

    sendTalkMsg(str, function(ret, err){
        sending = false;
        hideLoading();
        if(err){
            showResult('发送失败');
            sendFail(content);
            return
        }
        getLatestMessages()
        sendSuccess();
    })

    //rongcloud.sendTextMessage({
    //    conversationType: 'PRIVATE',
    //    targetId: id,
    //    text: str,
    //    extra: ''
    //}, function (ret, err) {
    //    if (ret.status == 'prepare') {
    //        sendtime = ret.result.message.sentTime;
    //    } else if (ret.status == 'success') {
    //        var tips = juicer(list_tpl, {
    //            isfirst: true,
    //            list: [{
    //                content: {text: str, extra: ''},
    //                messageDirection: 'SEND',
    //                messageId: ret.result.message.messageId,
    //                objectName: 'RC:TxtMsg',
    //                sentTime: sendtime,
    //                sentStatus: 'SENT'
    //            }]
    //        });
    //        list_box.append(tips);
    //        api.parseTapmode();
    //        sending = false;
    //        setTimeout(function(){
    //            api.pageDown({bottom: true});
    //        }, 300);
    //        hideLoading();
    //        sendSuccess();
    //        api.execScript({
    //            name: 'root',
    //            script: 'refreshMsgNumber()'
    //        });
    //    } else if (ret.status == 'error') {
    //        hideLoading();
    //        sending = false;
    //        showResult('发送失败');
    //        sendFail(content);
    //    }
    //});
}

// 发送图片
function sendPhoto(src) {
    if (sending) {
        return;
    }
    sending = true;
    showLoading();
    compressImg({src: src, id: 'chat_img'}, function(file){
        rongcloud.sendImageMessage({
            conversationType: 'PRIVATE',
            targetId: id,
            imagePath: file,
            extra: ''
        }, function (ret, err) {
            if (ret.status == 'success') {
                var tips = juicer(list_tpl, {
                    isfirst: true,
                    list: [{
                        content: {imageUrl: file},
                        messageDirection: 'SEND',
                        messageId: ret.result.message.messageId,
                        objectName: 'RC:ImgMsg',
                        sentTime: sendtime,
                        sentStatus: 'SENT'
                    }]
                });
                list_box.append(tips);
                api.parseTapmode();
                sending = false;
                setTimeout(function(){
                    api.pageDown({bottom: true});
                }, 300);
                hideLoading();
                obj_chatbox.closeKeyboard();
                api.execScript({
                    name: 'root',
                    script: 'refreshMsgNumber()'
                });
            } else if (ret.status == 'error') {
                sending = false;
                hideLoading();
                showResult('发送失败');
            }
        });
    }, function() {
        sending = false;
        hideLoading();
        showResult('发送失败');
    });
}

// 发送位置
function sendPosition(str, lon, lat, city) {
    sending = true;
    showLoading();
    var extra = '{MsgType:"position",position:"' + str + '",lon:"' + lon + '",lat:"' + lat + '"}';
    rongcloud.sendTextMessage({
        conversationType: 'PRIVATE',
        targetId: id,
        text: '[位置：' + str +']',
        extra: extra
    }, function (ret, err) {
        if (ret.status == 'success') {
            var tips = juicer(list_tpl, {
                isfirst: true,
                list: [{
                    content: {text: '[位置：' + str + ']', extra: extra},
                    messageDirection: 'SEND',
                    messageId: ret.result.message.messageId,
                    objectName: 'RC:TxtMsg',
                    sentTime: sendtime,
                    sentStatus: 'SENT'
                }]
            });
            list_box.append(tips);
            api.parseTapmode();
            sending = false;
            setTimeout(function(){
                api.pageDown({bottom: true});
            }, 300);
            hideLoading();
            obj_chatbox.closeKeyboard();
            api.execScript({
                name: 'root',
                script: 'refreshMsgNumber()'
            });
        } else if (ret.status == 'error') {
            sending = false;
            hideLoading();
            showResult('发送失败');
        }
    });
}

// 打开图片
function openImg(obj) {
    if (click_allowed) {
        var $this = $(obj);
        var src = $this.attr('src');
        api.openWin({
            name: 'win_image',
            url: 'widget://html/image_browser.html',
            bounces: false,
            allowEdit: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: false,
            pageParam: {
                imgs: [{src: src, id: ''}],
                index: 0
            },
            animation: {
                type: 'none',
                subType: 'from_right',
                duration: 0
            }
        });
    }
}

// 打开地图
function openMap(obj) {
    if (click_allowed && !menu_show) {
        var $this = $(obj);
        openWin_Map($this.text(), $this.data('lat'), $this.data('lon'));
    }
}

// 打开用户自己的个人页
function openMyPage() {
    if (click_allowed) {
        // openWin_MyPage();
    }
}

// 打开用户个人页
function openUserPage(mid) {
    if (click_allowed) {
        // openWin_UserPage(mid);
    }
}

var build_avatar_target = function(obj) {
    if (avatar != null && avatar != '') {
        return '<img src="' + avatar + '" alt="">';
    } else {
        return '<img class="no-avatar" src="' + avatar_default + '" alt="">';
    }
}
var build_avatar_me = function(obj) {
    if (avatar_me != null && avatar_me != '') {
        return avatar_me;
    } else {
        return avatar_default;
    }
}
var build_content = function(obj) {
    var extra = obj.content.extra;
    var str;
    if (extra != null && extra != '') {
        extra = eval('(' + extra + ')');
        if (extra.MsgType != null && extra.MsgType == 'position') {
            str = '<p class="txt position" tapmode="" onclick="openMap(this)" data-lat="' + extra.lat + '" data-lon="' + extra.lon + '">' + extra.position + '</p>';
        } else {
            str = '<p class="txt">' + obj.content.text + '</p>';
        }
    } else {
        str = '<p class="txt">' + obj.content.text + '</p>';
    }
    str = str.replace(/\r\n/g, "<br>").replace(/\n/g, "<br>");
    return convertEmoji(utf16_to_ucs2(str), '../../image/');
}
var build_arr = function(obj) {
    if (obj.objectName == 'RC:TxtMsg') {
        var extra = obj.content.extra;
        if (extra != '') {
            extra = eval('(' + extra + ')');
        } else {
            extra = {};
        }
        if (extra.MsgType == null || extra.MsgType != 'position') {
            return 'bg';
        }
    }
    return '';
}

var build_time = function(time) {
    if (time == null || time == '') return '';
    var dt = new Date(time);
    var now = new Date();
    var str = '';
    if (!timeline_temp) {
        var hour = dt.getHours();
        if (hour < 10) {
            hour = '0' + hour;
        }
        var min = dt.getMinutes();
        if (min < 10) {
            min = '0' + min;
        }
        if (dt.getFullYear() == now.getFullYear() && dt.getMonth() == now.getMonth() && dt.getDate() == now.getDate()) {
            str = '<p class="timeline">今天 ' + hour + ':' + min + '</p>';
        } else {
            str = '<p class="timeline">' + (dt.getMonth() + 1) + '月' + dt.getDate() + '日 ' + hour + ':' + min + '</p>';
        }
        timeline_temp = dt;
    } else {
        var year = dt.getFullYear();
        var month = dt.getMonth();
        var day = dt.getDate();
        var hour = dt.getHours();
        var min = dt.getMinutes();
        if (min != timeline_temp.getMinutes() || hour != timeline_temp.getHours() || day != timeline_temp.getDate() || month != timeline_temp.getMonth() || year != timeline_temp.getFullYear()) {
            if (hour < 10) {
                hour = '0' + hour;
            }
            if (min < 10) {
                min = '0' + min;
            }
            if (year == now.getFullYear() && month == now.getMonth() && day == now.getDate()) {
                str = '<p class="timeline">今天 ' + hour + ':' + min + '</p>';
            } else {
                str = '<p class="timeline">' + (month + 1) + '月' + day + '日 ' + hour + ':' + min + '</p>';
            }
            timeline_temp = dt;
        }
    }
    return str;
}
var build_time_first = function(time) {
    if (time == null || time == '') return '';
    var dt = new Date(time);
    var now = new Date();
    var str = '';
    if (!timeline_last) {
        var hour = dt.getHours();
        if (hour < 10) {
            hour = '0' + hour;
        }
        var min = dt.getMinutes();
        if (min < 10) {
            min = '0' + min;
        }
        if (dt.getFullYear() == now.getFullYear() && dt.getMonth() == now.getMonth() && dt.getDate() == now.getDate()) {
            str = '<p class="timeline">今天 ' + hour + ':' + min + '</p>';
        } else {
            str = '<p class="timeline">' + (dt.getMonth() + 1) + '月' + dt.getDate() + '日 ' + hour + ':' + min + '</p>';
        }
        timeline_last = dt;
    } else {
        var year = dt.getFullYear();
        var month = dt.getMonth();
        var day = dt.getDate();
        var hour = dt.getHours();
        var min = dt.getMinutes();
        if (min != timeline_last.getMinutes() || hour != timeline_last.getHours() || day != timeline_last.getDate() || month != timeline_last.getMonth() || year != timeline_last.getFullYear()) {
            if (hour < 10) {
                hour = '0' + hour;
            }
            if (min < 10) {
                min = '0' + min;
            }
            if (year == now.getFullYear() && month == now.getMonth() && day == now.getDate()) {
                str = '<p class="timeline">今天 ' + hour + ':' + min + '</p>';
            } else {
                str = '<p class="timeline">' + (month + 1) + '月' + day + '日 ' + hour + ':' + min + '</p>';
            }
            timeline_last = dt;
        }
    }
    return str;
}

//	juicer.register('build_avatar_target', build_avatar_target);
//	juicer.register('build_avatar_me', build_avatar_me);
//	juicer.register('build_time', build_time);
//	juicer.register('build_time_first', build_time_first);
//	juicer.register('build_content', build_content);
//	juicer.register('build_arr', build_arr);

// 请求列表
function getList1() {
    loading = true;
    rongcloud.getHistoryMessages({
        conversationType: 'PRIVATE',
        targetId: id,
        oldestMessageId: messageid,
        count: 20
    }, function (ret, err) {
        if (ret.status == 'success') {
            if (isFirst) {
                var list = fixJSON(ret.result);
                var tips = juicer(list_tpl, {
                    isfirst: true,
                    list: list
                });
                list_box.html(tips);
                api.parseTapmode();
                isFirst = false;
                if (list.length > 0) {
                    messageid = list[0].messageId;
                    messageid_new = list[list.length - 1].messageId;
                    sendtime_last = list[0].sentTime;
                }
                loading = false;
                api.refreshHeaderLoadDone();
                api.execScript({
                    name: 'root',
                    script: 'refreshMsgNumber()'
                });
                setTimeout(function(){
                    api.pageDown({bottom: true});
                    setTimeout(function(){
                        $(window).scrollTop($(window).scrollTop() - 1);
                    }, 100);
                }, 300);
            } else {
                var list = fixJSON(ret.result);
                if (list.length == 0) {
                    nomore = true;
                    getHistory();
                    return;
                }
                var tips = juicer(list_tpl, {
                    isfirst: false,
                    list: list
                });
                list_box.prepend(tips);
                api.parseTapmode();
                if (list.length > 0) {
                    messageid = list[0].messageId;
                }
                loading = false;
                api.refreshHeaderLoadDone();
            }
        } else {
            api.refreshHeaderLoadDone();
            loading = false;
        }
    })
}

// 获取历史消息
function getHistory() {
    api.refreshHeaderLoadDone();
    loading = false;
    return;
    rongcloud.getRemoteHistoryMessages({
        conversationType: 'PRIVATE',
        targetId: id,
        dateTime: sendtime_last,
        count: 20
    }, function(ret, err){
        if (ret.status == 'success') {
            var list = fixJSON(ret.result);
            if (list.length == 0) {
                return;
            }
            var tips = juicer(list_tpl, {
                isfirst: false,
                list: list
            });
            list_box.prepend(tips);
            api.parseTapmode();
            if (list.length > 0) {
                sendtime_last = list[0].sentTime;
            }
            loading = false;
            api.refreshHeaderLoadDone();
        } else {
            api.refreshHeaderLoadDone();
            loading = false;
        }
    })
}

// 接收新消息
function readNew() {
    if (loading_new) {
        return;
    }
    loading_new = true;
    rongcloud.getLatestMessages({
        conversationType: 'PRIVATE',
        targetId: id,
        count: 20
    }, function (ret, err) {
        if (ret.status == 'success') {
            var list = ret.result;
            if (list.length == 0) {
                loading_new = false;
                return;
            }
            var list_temp = [];
            for (var i = 0; i < list.length; i++) {
                if (list[i].messageId > messageid_new && list[i].messageDirection == 'RECEIVE') {
                    list_temp.push(list[i]);
                }
            }
            list = fixJSON(list_temp);
            messageid_new = list[list.length - 1].messageId;
            var tips = juicer(list_tpl, {
                isfirst: true,
                list: list
            });
            list_box.append(tips);
            api.parseTapmode();
            loading_new = false;
            api.execScript({
                name: 'root',
                script: 'refreshMsgNumber()'
            });
            setTimeout(function(){
                api.pageDown({bottom: true});
                setTimeout(function(){
                    $(window).scrollTop($(window).scrollTop() - 1);
                }, 100);
            }, 300);
        } else {
            loading_new = false;
        }
    })
}

var update_timer = null
var update_timestamp = 0
var load_more_timestamp = 0
var is_sending = false
var pager = new Paginator()
var vm = new Vue({
    el: '#wrap',
    data: {
        datalist: pager.datalist
    },
    methods: {
    }
})

function getList(isclear) {
    var list_more = $('#list-more')
    var url = config.urls.talk_msg_list
    //console.log('talk_key==' + id)

    ajaxGet(url, {talk_key: id, timestamp: load_more_timestamp}, function (ret, err) {
        api.refreshHeaderLoadDone();
        list_more.removeClass('loading');

        if(ret.data.list && ret.data.list != ''){
            $.each(ret.data.list, function(index, item){
                item.content = build_content(item)
                item.add_time_str = build_time(parseInt(item.add_timestamp/1000))
            })
        }
        var bottom_offset = $(document).height() - $(window).height() - $(window).scrollTop()
        pager.isinsert = 1
        pager.onLoadDataComplete(!err, ret.data)
        pager.isinsert = 0
        if (err) {
            return;
        }
        //$(window).scrollTop($(window).scrollTop() - 1);
        //if(pager.datalist.length == 0) {
        //    no_result.show();
        //} else {
        //    no_result.hide();
        //}
//                setTimeout(function(){
//                    if (isclear) lazyload_fix($(".list-item"), 3);
//                    $(".list-item img.hidden").lazyload();
//                }, 100)
        api.parseTapmode();

        if (!pager.hasmore && pager.datalist.length > 0) {
            list_more.addClass('nomore');
        } else {
            list_more.removeClass('nomore');
        }
        if(isclear) scrollToBottom()
        else {
            setTimeout(function(){
                $(window).scrollTop($(document).height() - $(window).height() - bottom_offset - 50);
            }, 50)
        }

        if(pager.datalist.length > 0) {
            if(pager.page == 1){
                update_timestamp = pager.datalist[pager.datalist.length - 1]['add_timestamp']
            }
            load_more_timestamp = pager.datalist[0]['add_timestamp']
        }
    })
}

//setTimeout(function () {
//    getList()
//}, 2000)

function getLatestMessages() {
    ajaxGet(config.urls.talk_msg_refresh, {talk_key: id, timestamp: update_timestamp}, function (ret, err) {
        if (err || ret.data.list.length <= 0) {
            return;
        }
        $.each(ret.data.list, function(index, item){
            item.content = build_content(item)
            item.add_time_str = build_time(parseInt(item.add_timestamp/1000))
        })
        pager.datalist.addAll(ret.data.list)
        update_timestamp = pager.datalist[pager.datalist.length - 1]['add_timestamp']

        api.parseTapmode();
        scrollToBottom()
    })
}

function sendTalkMsg(content, cbk) {
    is_sending = true
    ajaxPost(config.urls.talk_msg_send, {talk_key: id, content: content}, function (ret, err) {
        is_sending = false

        if(cbk) cbk(ret, err)
        if (err) {
            return;
        }
        // getLatestMessages()
    }, 1)
}

function onCloseWin() {
    if(update_timer) clearInterval(update_timer)
}

function scrollToBottom() {
    setTimeout(function(){
        api.pageDown({bottom: true});
        //setTimeout(function(){
        //    $(window).scrollTop($(window).scrollTop() - 1);
        //}, 100);
    }, 300);
}

function scrollToTop() {
    setTimeout(function(){
        $(window).scrollTop($(window).scrollTop() - 1);
    }, 100);
}

apiready = function() {
  onApiReady();
    sys = api.systemType;
    id = api.pageParam.id + '';
    log('id=' + id)
    if(!id) id = '3-16'
    var is_sys_talk = id.indexOf('1-') == 0
    //rongcloud = api.require('rongCloud2');
    avatar_me = ''; //$api.getStorage('userinfo').data.member_avatar;
    var touch_id = 0;
    var obj_clip = api.require('clipBoard');
    var mediaScanner = api.require('UIMediaScanner');
    list_tpl = $('#list-tpl').html();
    list_box = $('#list-box');
    list_loading = $('#list-more');

    scroll_click(sys);

    //getOtherUserInfo(id, function(data){
    //    avatar = data.member_avatar;
    //    if (avatar != null && avatar != '') {
    //        $('img.no-avatar').attr('src', avatar);
    //    }
    //})

    getList(true);

    update_timer = setInterval(getLatestMessages, 5000)

    if(!is_sys_talk) {
        initChatBox()
    }

    // 下拉刷新
    api.setRefreshHeaderInfo({
        visible: true,
        loadingImg: 'widget://image/common/loading.png',
        bgColor: '#f3f3f3',
        textColor: '#999',
        textDown: '加载更多...',
        textUp: '松开加载...',
        showTime: false
    }, function(ret, err){
        isTouch = false;
        if (loading) {
            return;
        }
        // 当没有网络时直接结束刷新
        if (api.connectionType === 'none') {
            api.refreshHeaderLoadDone();
            showResult('当前网络不可用<br>请检查你的网络设置');
            return;
        }
        //if (nomore) {
        //    getHistory();
        //} else {
        //    getList();
        //}
        getList();
    });

    // 监听滑动到底部的事件
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 0
        }
    }, function(ret, err){
        isTouch = false;
    });

    $('html').on('touchstart', '.click-item .txt', function(){
        var $this = $(this);
        copy_content = $this.text();
        isTouch = true;
        touch_id = (touch_id + 1) % 1000;
        var touch_id_temp = touch_id;
        setTimeout(function(){
            if (isTouch && touch_id_temp == touch_id) {
                isTouch = false;
                menu_show = true;
                api.actionSheet({
                    buttons: ['复制']
                },function(ret,err){
                    menu_show = false;
                    var index = ret.buttonIndex;
                    if (index === 1) {
                        obj_clip.set({
                            value: copy_content
                        }, function(ret, err){});
                    }
                });
            }
        }, 800);
    }).on('touchmove', '.click-item .info', function(){
        isTouch = false;
    }).on('touchend', '.click-item .info', function(){
        isTouch = false;
    })
}

function initChatBox() {
    obj_chatbox = api.require('UIChatBox');
    obj_chatbox.open({
        placeholder: '点击输入文字...', //
        maxRows: 1,
        emotionPath: 'widget://image/emoji',
        texts: {
            sendBtn: {
                title: "发送"
            }
        },
        styles: {
            inputBar: {
                borderColor: '#f2f2f2',
                bgColor: '#f8f8f8'
            },
            inputBox: {
                borderColor: '#ccc',
                bgColor: '#fff'
            },
            indicator: {
                target: 'emotionPanel',
                color: '#c4c4c4',
                activeColor: '#fcd953'
            },
            sendBtn: {
                titleColor: '#fff',
                bg: '#0095f4' ,
                activeBg: '#0095f4',
                titleSize: 15
            },
            emotionBtn: {
                normalImg: 'widget://image/common/icon_chat_emoji_2.png'
            }
            //extrasBtn: {
            //    normalImg: 'widget://image/common/icon_chat_more_2.png'
            //}
        }
        //extras: {
        //    titleSize: 14,
        //    titleColor: '#9e9e9e',
        //    btns: [
        //        //{
        //        //    title: '',
        //        //    normalImg: 'widget://image/common/transparent.png',
        //        //    activeImg: 'widget://image/common/transparent.png'
        //        //}
        //        //{
        //        //    title: '拍照',
        //        //    normalImg: 'widget://image/icon_chat_camera.png',
        //        //    activeImg: 'widget://image/icon_chat_camera.png'
        //        //}
        //        //, {
        //        //    title: '相册',
        //        //    normalImg: 'widget://image/icon_chat_album.png',
        //        //    activeImg: 'widget://image/icon_chat_album.png'
        //        //}
        //        // , {
        //	//	title: '位置',
        //	//	normalImg: 'widget://image/icon_chat_position.png',
        //	//	activeImg: 'widget://image/icon_chat_position.png'
        //	//}
        //    ]
        //}
    }, function(ret){
        if (ret.eventType == 'send'){
            submit(ret.msg);
        } else if (ret.eventType == 'clickExtras') {
            var index = ret.index;
            if (index === 0) {
                api.getPicture({
                    sourceType: 'camera',
                    encodingType: 'jpg',
                    mediaValue: 'pic',
                    destinationType: 'url',
                    allowEdit: false,
                    quality: 100,
                    saveToPhotoAlbum: false
                }, function(ret, err){
                    if (ret) {
                        var data = ret.data;
                        if (data === '') {
                            return;
                        }
                        sendPhoto(data);
                    }
                });
            } else if (index === 1) {
                mediaScanner.open({
                    exchange: true,
                    column: 4,
                    classify: false,
                    max: 1,
                    sort: {
                        key: 'time',
                        order: 'desc'
                    },
                    texts: {
                        stateText: '已选择*项',
                        cancelText: '取消',
                        finishText: '完成'
                    },
                    styles: {
                        bg: '#fff',
                        mark: {
                            icon: '',
                            position: 'bottom_left',
                            size: 20
                        },
                        nav: {
                            bg: '#ffe14d',
                            stateColor: '#000',
                            stateSize: 18,
                            cancelBg: 'rgba(0,0,0,0)',
                            cancelColor: '#000',
                            cancelSize: 18,
                            finishBg: 'rgba(0,0,0,0)',
                            finishColor: '#000',
                            finishSize: 18
                        }
                    }
                }, function(ret){
                    if(ret && ret.list.length > 0){
                        mediaScanner.transPath({
                            path: ret.list[0].path
                        }, function(ret){
                            sendPhoto(ret.path);
                        });
                    }
                });
            } else if (index === 2) {
                api.openWin({
                    name: 'win_report_map_position',
                    url: 'widget://html/report/map_position.html',
                    bounces: false,
                    vScrollBarEnabled: false,
                    hScrollBarEnabled: false,
                    slidBackEnabled: true,
                    pageParam: {
                        winname: 'win_chat',
                        framename: 'chat_main',
                        scriptname: 'sendPosition',
                        btnname: '发送',
                        name: ''
                    },
                    animation: {
                        type: 'fade',
                        subType: 'from_right',
                        duration: 300
                    }
                });
            }
        }
    });
}
